/*
Actors:
Abeast
beastRed
BeastBlue
*/

Actor(Abeast)//Armored Beast/Behemoth
{
		file(ABehemothHeader);
		rank(_RankGeneral);

		startstate(StateNormal);
		startaction(AbeastIdle);

		//AI variables. All characters using copgen.hxx needs these defined to work properly
		float(_declare,AIControl,0);
		float(_declare,AIHideControl,0);
		float(_declare,AIUsage,_AIUAdvanceIfEnemyUnseen);
		float(_declare,AIAbility,_AIAJump|_AIANoCrawl|_AIANoBoneCollision|_AIANoThrown);	//_AIAAlwaysInCombatMode|
		float(_declare,AIManPowerThreshold,300);
		float(_declare,AIPowerRatingThreshold,50);
		float(_declare,AIGrenadeThrowThreshold,10);
		float(_declare,BreathOn,0)

		#include	"messiahscripts\enemies\copgen.hxx"



		if(VAICon!=0)
		{
			if(VAIState==_AIstateShutDown)
			{
				if(VActorFlag==_AFLAGnoai)
				{
					if(VAction!=ABeastShutDown)
					{
						SpawnAction(ABeastShutDown);
						ActorFlag(_or,_AFLAGnopossesion);
					}
				}
				else
				{
					if(VOAction==ABeastShutDown)
					{
						SpawnAction(ABeastPowerUp);
						ActorFlag(_clr,_AFLAGnopossesion);
					}
				}
			}
		}

		if(VAIlaststate==_AIstateShutDown)
		{
			if(BreathOn==0)
			{
				sample(SFXBreathing,-1);
				float(_set,BreathOn,1);
			}
		}
		elseif(VAIState==_AIstateShutDown)
		{
			if(BreathOn==1)
			{
				samplestop(SFXBreathing);
				float(_set,BreathOn,0);
			}
		}
		elseif(vactivetime==0)
		{
			if(BreathOn==0)
			{
				sample(SFXBreathing,-1);
				float(_set,BreathOn,1);
			}
		}

		if(vstate==statedead)
		{
			if(BreathOn==1)
			{
				samplestop(SFXBreathing);
				float(_set,BreathOn,0);
			}
		}

		if(VAction==ABeastStandShoot && VFrame==0)
		{
			vector(_set,TmpVector,0,0,0);
			spawnactorbone(BulletMachineGun,TmpVector,Gactorpos,Gactorine,8);
			vector(_set,tmpvector,250,167,20);
			spawnlight(flash_light,8,Gactorpos,tmpvector,EmptyVector,350);
		}
}



Actor(beast)
{
		file(BehemothHeader);
		rank(_RankGeneral);

		startstate(StateNormal);
		startaction(beastIdle);

		//AI variables. All characters using copgen.hxx needs these defined to work properly
		float(_declare,AIControl,0);
		float(_declare,AIHideControl,0);
		float(_declare,AIUsage,0);
		float(_declare,AIAbility,_AIAJump|_AIASpecialSecondaryWeapon|_AIANoCrawl|_AIANoBoneCollision|_AIAAlwaysInCombatMode|_AIANoThrown);
		float(_declare,AIManPowerThreshold,300);
		float(_declare,AIPowerRatingThreshold,50);
		float(_declare,AIGrenadeThrowThreshold,10);

		#include	"messiahscripts\enemies\copgen.hxx"

		if(vactivetime==0)
		{
			sample(SFXBreathing,-1);
		}
		if(vstate==statedead)
		{
			samplestop(SFXBreathing);
		}
}


Actor(chotbeast)
{
		file(chotBehemothHeader);
		rank(_RankGeneral);

		startstate(StateNormal);
		startaction(BeastIdle);

		//AI variables. All characters using copgen.hxx needs these defined to work properly
		float(_declare,AIControl,0);
		float(_declare,AIHideControl,0);
		float(_declare,AIUsage,0);
		float(_declare,AIAbility,_AIAJump|_AIASpecialSecondaryWeapon|_AIANoCrawl|_AIANoBoneCollision|_AIAAlwaysInCombatMode|_AIANoThrown);
		float(_declare,AIManPowerThreshold,300);
		float(_declare,AIPowerRatingThreshold,50);
		float(_declare,AIGrenadeThrowThreshold,10);

		#include	"messiahscripts\enemies\copgen.hxx"
}



Actor(bouncer)
{
		file(bouncerHeader);
		rank(_RankGeneral);

		startstate(StateNormal);
		startaction(beastIdle);

		//AI variables. All characters using copgen.hxx needs these defined to work properly
		float(_declare,AIControl,0);
		float(_declare,AIHideControl,0);
		float(_declare,AIUsage,0);
		float(_declare,AIAbility,_AIAJump|_AIASpecialSecondaryWeapon|_AIANoCrawl|_AIANoBoneCollision|_AIAAlwaysInCombatMode|_AIANoThrown);
		float(_declare,AIManPowerThreshold,300);
		float(_declare,AIPowerRatingThreshold,50);
		float(_declare,AIGrenadeThrowThreshold,10);

		#include	"messiahscripts\enemies\copgen.hxx"
}


