//VarKey21	-   controls help text and various events
//				0	triggers the Objectives message at the beginning (Stor_04)
//				1	console system explanation (War_ent) 
//				2	lift system explanation (from War_03 or Stor_02)
//				3   Objectives messages at the beginning of Annex (Annx_01)
//VarKey22	- level progress indicator (doors locked, flic states, etc.)
//				0	war_ent, entered for the first time
//				1	war_ent, open door flic segment has been set
//				2	war_ent, door to war_03 has been opened
//				3	war_ent, stor_02, elevator power is now on
//				4	elevator power on flic initiated
//				12	War_rad, Door to annex unlocked
//				13	annx_10, Open door.
//VarKey23	- has the alarm in stor_02 been set (elevator power been restored), also a delay
//				for the cops that come up the elevator
//VarKey24	- has the worked been mashed in stor_01? 
//				0	worker is ok, set lower tank button to be green
//				1	lower tank button has been pressed, set button to be red
//				2	the worker has been crushed
//				3	medic should be spawned in war_ent
//				4	medic has been spawned
//VarKey25	- delay from when worker has been crushed to when medic comes in
//VarKey26	- War_rad timer for ending sequence.
//			- 1 If a weapon has been taken in Annx_06
//			- 2 if both weapon were taken in Annx_06
//VarKey27	- Anim synch for droid
//VarKey28	- Annex Objective Completion
//			  0		Lasers turned off (Annx_06)
//			  1		Power console Activated	(Annx_07)
//VarKey29	- Polyvalent variable used to determine sample/frame synchro.
//VarKey30	- Check progression of the droid down EL_X03

SubRoutine(InitSceneSound14)
{
			//ambient sound Fx
			#include	"messiahscripts\stages\scene5sfx.hxx"

			//convier1
			vector(_set,Gactorpos,-16434,24340,20468);
			sample(SFXIndAmbient02,Gactorpos);

			//cinvier2
			vector(_set,Gactorpos,-16787,24487,18300);
			sample(SFXIndustrial9,Gactorpos);

			vector(_set,Gactorpos,-16836,24243,18810);
			sample(SFXSewerHammer,Gactorpos);

			//convier3
			vector(_set,Gactorpos,-15300,24725,18330);
			sample(SFXIndustrial9,Gactorpos);

			vector(_set,Gactorpos,-14410,24175,18570);
			sample(SFXIndustrial9,Gactorpos);

			vector(_set,Gactorpos,-14410,24175,20000);
			sample(SFXIndustrial9,Gactorpos);


			vector(_set,Gactorpos,-15230,24295,20075);
			sample(SFXShaftRotate2,Gactorpos);
}

SubRoutine(InitScene14)
{
			vector(_set,Gactorangle,0,1024,0);
			InitActor(Bob1,0,Gactorangle,"stor_04");
			
			// Mike's enemies :
			
//			#include "messiahscripts\enemies\mike.spt"
//			#include "messiahscripts\enemies\mikeware.spt"
			#include "messiahscripts\enemies\convey.spt"

			// Reset all the variables
			float(_set,VarKey21,0);
			float(_set,VarKey22,0);
			float(_set,VarKey23,0);
			float(_set,VarKey24,0);
			float(_set,VarKey25,0);
			float(_set,VarKey26,0);
			float(_set,VarKey27,0);
			float(_set,VarKey28,0);
			float(_set,VarKey29,0);
			float(_set,VarKey30,0);
			float(_set,CameraPan,0);
			float(_set,MaxNrSpawn,5);
			float(_set,LiftMsg,0)
			float(_set,timer,0);
			float(_set,timer2,0);
			float(_set,timer3,0);


			callsub(InitSceneSound14);
}

SubRoutine(MainScene14)
{
/////////////////////////
//// CONVEYER SCRIPT ////
/////////////////////////
		if(VSetActive=="Convier2")
		{
			CurEnvTriggerSet("Convier2","cage04");
			call(expset1,-1400,0,2);

			call(SetParticleSetID,"Convier2");

			if(VRnd<128)
			{
				//End of conveyer belt
				//

				vector(_set,Gactorine,0,-6,0);
				vector(_set,TmpVector1,-17185,24690,18300);
				vector(_set,TmpVector2,-17185,24690,18400);
				vector(_set,TmpVector3,-17185,24690,18190);

				SpawnParticle(fx_firejets,-1,TmpVector1,Gactorine,fx_scale5);
				SpawnParticle(fx_firejets,-1,TmpVector2,Gactorine,fx_scale5);
				SpawnParticle(fx_firejets,-1,TmpVector3,Gactorine,fx_scale5);

				vector(_Set,TmpVector,30,75,0);
				vector(_sub,TmpVector1,TmpVector);
				vector(_sub,TmpVector2,TmpVector);
				vector(_sub,TmpVector3,TmpVector);

				if(skipcollidecount>=5)
				{
					//End of conveyer belt
					//
					call(CheckActorCollision,TmpVector1,75,0,_COLfire);
					call(CheckActorCollision,TmpVector2,75,0,_COLfire);
					call(CheckActorCollision,TmpVector3,75,0,_COLfire);


					//	top of the vertically moving boxes
					//
					vector(_set,Gactorpos,-16675,25125,18640);
					call(CheckActorCollision,GActorpos,128,0,_COLfire);
				}



				//	top of the vertically moving boxes
				//
				vector(_set,Gactorpos,-16817,25106,18803);
				vector(_set,Gactorine,6,0,-6);
				SpawnParticle(fx_firejets,-1,Gactorpos,Gactorine,fx_scale5);

				vector(_set,Gactorpos,-16817,25026,18803);
				vector(_set,Gactorine,6,0,-6);
				SpawnParticle(fx_firejets,-1,Gactorpos,Gactorine,fx_scale5);

				vector(_set,Gactorpos,-16817,24942,18803);
				vector(_set,Gactorine,6,0,-6);
				SpawnParticle(fx_firejets,-1,Gactorpos,Gactorine,fx_scale5);

				vector(_set,Gactorpos,-16860,25112,18646);
				vector(_set,Gactorine,6,-6,6);
				SpawnParticle(fx_firejets,-1,Gactorpos,Gactorine,fx_scale5);

				vector(_set,Gactorpos,-16773,25112,18558);
				vector(_set,Gactorine,6,-6,6);
				SpawnParticle(fx_firejets,-1,Gactorpos,Gactorine,fx_scale5);

				vector(_set,Gactorpos,-16687,25112,18473);
				vector(_set,Gactorine,6,-6,6);
				SpawnParticle(fx_firejets,-1,Gactorpos,Gactorine,fx_scale5);

				vector(_set,Gactorpos,-16667,25112,18839);
				vector(_set,Gactorine,-6,-6,-6);
				SpawnParticle(fx_firejets,-1,Gactorpos,Gactorine,fx_scale5);

				vector(_set,Gactorpos,-16580,25112,18751);
				vector(_set,Gactorine,-6,-6,-6);
				SpawnParticle(fx_firejets,-1,Gactorpos,Gactorine,fx_scale5);

				vector(_set,Gactorpos,-16494,25112,18667);
				vector(_set,Gactorine,-6,-6,-6);
				SpawnParticle(fx_firejets,-1,Gactorpos,Gactorine,fx_scale5);
			}
		}
		if(VSetActive=="Convier3")
		{
			CurEnvTriggerSet("Convier3","belt01");
			//call(expset1,-1400,0,4);
			call(expset1,-3000,0,4);
			call(expset2,-1400,0,1);

			CurEnvTriggerSet("Convier3","belt02");
			call(expset1,-1400,0,2);
			//call(expset2,-1400,0,4);
			call(expset2,-3000,0,4);
		}

		if(skipcollidecount>=5)
		{
			float(_set,skipcollidecount,0);
		}
		float(_add,skipcollidecount,1);
}






SubRoutine(BackgroundTriggerChecksScene14)
{
/////////////////////////
//// CONVEYER SCRIPT ////
/////////////////////////
	if(VCurSet=="convier1")
	{
		if(VTrigger==_DIRaction && VAICon==0)
		{
			CurEnvTrigger("convtrig");
			if(VTrigger==_DIREnvTrigger && VKeyObjTriggered==0)
			{
				callsub(DoorOpen,1,1);
				Direction(_clr,_DIRaction);
			}

			CurEnvTrigger("trig2");
			if(VTrigger==_DIREnvTrigger)
			{
				CurEnvTrigger("enemy01");
				if(VKeyObjTriggered==0)
				{
					call(ActivateButton,"door to conveyer area activated",-1,FALSE);
					call(ActivateButtonSample,SFXValidFunction);
					callsub(DoorOpen,3,1);		//maybe a 2 instead of 3
				}
				Direction(_clr,_DIRaction);
			}
		}

		CurEnvTrigger("enemy01");
		if(VAICon==0 && Vtrigger==_DIREnvTrigger && VKeyObjTriggered==1)
		{
			CurEnvTriggerSet("convier2","CAGE03");
			if(VKeyObjTriggered==0)
			{
				call(KeyObjTrigger,2,1,-1);
				call(KeyObjActiveSegment,0,2);
				kfsample(SFXLiftStart,SFXLiftMove,-1,SFXLiftEnd);
			}
		}
	}
	elseif(VCurSet=="convier2")
	{
		CurEnvTrigger("cage04");
		if(VAICon==0 && VTrigger==_DIREnvTrigger && VKeyObjTriggered==0)
		{
			call(KeyObjTrigger,2,1,-1);
			call(KeyObjActiveSegment,0,2);
			kfsample(SFXLiftStart,SFXLiftMove,-1,SFXLiftEnd);
		}
	}
	elseif(VCurSet=="convier3")
	{
/*
		CurEnvTrigger("Belt02");
		PrintI("VKeyObjFrame: ",VKeyObjFrame);
		if(VKeyObjFrame==20)
		{
		}
		else
		{
		}
*/



		CurEnvTrigger("transit");
		if(VTrigger==_DIREnvTrigger && VKeyObjFrame==0)
		{
			callsub(DoorOpen,0,1);
		}

		if(VAICon==0 && VTrigger==_DIRaction)
		{
			CurEnvTrigger("Lifto");
			if(VTrigger==_DIREnvTrigger && VKeyObjTriggered==0)
			{
				call(KeyObjTrigger,3,1);
				call(ActivateButton,0,-1,FALSE);
				call(ActivateButtonSample,SFXValidFunction);
				kfsample(SFXLiftStart,SFXLiftMove,-1,SFXLiftEnd);
				Direction(_clr,_DIRaction);
			}

			CurEnvTrigger("Liftick");
			if(VTrigger==_DIREnvTrigger && VKeyObjTriggered==0)
			{
				call(KeyObjTrigger,7,1);
				call(ActivateButton,0,-1,FALSE);
				call(ActivateButtonSample,SFXValidFunction);
				kfsample(SFXLiftStart,SFXLiftMove,-1,SFXLiftEnd);
				Direction(_clr,_DIRaction);
			}

			float(_set,TmpFloat,0);
			if(VKeyObjFrame!=0)
			{
				float(_set,TmpFloat,1);
			}

			CurEnvTrigger("DoorSlide");
			if(VTrigger==_DIREnvTrigger && VKeyObjTriggered==0)
			{
				call(ActivateButton,0,-1,FALSE);
				call(ActivateButtonSample,SFXValidFunction);

				if(TmpFloat==0)
				{
					callsub(DoorOpen,0,1);
				}
				else
				{
					Message("Lift Called",250,10);
					CurEnvTrigger("Liftick");
					call(KeyObjTrigger,0,-1);
					kfsample(SFXLiftStart,SFXLiftMove,-1,SFXLiftEnd);
				}

				Direction(_clr,_DIRaction);
			}

		}
	}
}
