// Military Zone

//VarKey81
//	1 - mz_02 birdview sequence has been activated
//	2 - mz_02 birdview sequence is going on
//	4 - left control tower up/down bit
//	8 - left control tower up/down bit
//	16 - left gun is blown to bits
//	32 - right gun is blown to bits
//	64 - panel on right control tower is blown up
//	128 - mz_09 birdview sequence has been triggered
//	256 - mz_09 birdview sequence has been initialized
//	512 - mz_09 birdview sequence is going on
//	1024 - right control tower up/down bit
//	2048 - right control tower up/down bit
//	4096 - birdview set camera to normal
//	8192 - elevator in mz_01 is moving

//VarKey82
//	1 - mztunl1&2 door01 can be triggered
//	2 - mztunl1&2 door can be triggered
//	4 - beast1 is engaged
//	8 - beast2 is engaged
//	16 - beast3 is engaged
//	32 - door in mz_08 can be opened
//	64 - elevator up for mz_08
//	128 - elevator down for mz_08
//	256 - door in mz_08 can be opened
//	512	- tell abeast to be pissed
//	1024 - don't trigger pissed sequence again
//  2048 - door in mz_07 can be opened
//	4096 - Beam me up, Scotty !
//VarKey90 - a timer

SubRoutine(InitSceneSound17)
{
}

SubRoutine(InitScene17)
{
			vector(_set,Gactorangle,0,-1024,0);
			InitActor(Bob1,0,Gactorangle,"elevent");

			//Set of Variables for Military Zone
			float(_set,VarKey81,0);
			float(_set,VarKey82,0);
			float(_set,VarKey83,0);
			float(_set,VarKey84,0);
			float(_set,VarKey85,0);
			float(_set,VarKey86,0);
			float(_set,VarKey87,0);
			float(_set,VarKey88,0);
			float(_set,VarKey89,0);
			float(_set,VarKey90,0);

			#include "messiahscripts\enemies\military.spt"


			//	will be put in scene17sfx.hxx later
			//
			vector(_set,gactorpos,-14983,25048,8319);
			sample(SFXBirdSquak,Gactorpos);

			vector(_set,gactorpos,-5984, 24580, 7426);		//beast 1
			sample(SFXBreathing,gactorpos);
			vector(_set,gactorpos,-5687, 24580, 7426);		//beast 2
			sample(SFXBreathing,gactorpos);
			vector(_set,gactorpos,-5984, 24580, 6379);		//beast 3
			sample(SFXBreathing,gactorpos);

			vector(_set,gactorpos,-14976,24500,8649);
			sample(SFXGlobeIdle,Gactorpos);

			callsub(InitSceneSound17);
			
}

SubRoutine(MainScene17)
{
	//	SOUND EFFECTS FOR ALL LEVELS
	//
	if(VCurSet=="mztunl1")
	{
		CurEnvTrigger("arme");
		if(VKeyObjTriggered!=0)
		{
			vector(_set,Gactorpos,-8088,24573,10733);
			callsub(DispenserSound);
		}
		CurEnvTrigger("arme1");
		if(VKeyObjTriggered!=0)
		{
			vector(_set,Gactorpos,-7788,24573,10733);
			callsub(DispenserSound);
		}
	}



	//	CODE TO BE CHECKED THAT ARE NOT CHARACTER SPECIFIC
	//
	if(VSetActive=="mz_02")
	{
		if(VarKey82&=256)
		{
			float(_set,TmpFloat,0x7f00);
		}
		else
		{
			float(_Set,TmpFloat,0x7f0000);
		}
		CurEnvTriggerSet("mz_02","Door");
		call(ExpSet1,1,TmpFloat,0);

		if(VarKey81&=2 && VCutSceneFrameEqual==30)
		{
			sample(SFXBirdScream,-1);
		}
	}
	if(VSetActive=="mz_03")
	{
		if(VarKey81&=4)
		{
			CurEnvTriggerSet("Mz_03","TurretGo");
			if(VKeyObjTriggered==0)
			{
				CurEnvTriggerSet("Mz_03","OverRide");
				call(KeyObjTrigger,255,1);
				kfsample(SFXLiftStart,SFXLiftMove,-1,SFXLiftEnd);
				float(_clr,VarKey81,4);
			}
		}
		elseif(VarKey81&=8)
		{
			CurEnvTriggerSet("Mz_03","OverRide");
			if(VKeyObjTriggered==0)
			{
				CurEnvTriggerSet("Mz_03","TurretGo");
				call(KeyObjTrigger,0,-1);
				vector(_set,Gactorpos,-8687,24897,10201);
				Sample(SFXPneumatik,Gactorpos);
				float(_clr,VarKey81,8);
			}
		}
	}
	if(VSetActive=="mz_07")
	{
		if(VarKey82&=2048)
		{
			float(_set,TmpFloat,0x7f00);
		}
		else
		{
			float(_Set,TmpFloat,0x7f0000);
		}
		CurEnvTriggerSet("mz_07","Door");
		call(ExpSet1,1,TmpFloat,0);
	}

	if(VSetActive=="MZtunl1")
	{
		CurEnvTriggerSet("MZtunl1","Door01");
		if(VKeyObjTriggered==0)
		{
			float(_or,VarKey82,2);
			float(_set,TmpFloat,0x7f00);
		}
		else
		{
			float(_clr,VarKey82,2);
			float(_set,TmpFloat,0x7f0000);
		}

		CurEnvTriggerSet("MZtunl1","Door");
		call(expset1,1,TmpFloat,0);
		if(VKeyObjTriggered==0)
		{
			float(_or,VarKey82,1);
			float(_set,TmpFloat,0x7f00);
		}
		else
		{
			float(_clr,VarKey82,1);
			float(_set,TmpFloat,0x7f0000);
		}

		CurEnvTriggerSet("MZtunl1","Door01");
		call(expset1,1,TmpFloat,0);
	}
	if(VSetActive=="MZtunl2")
	{
		CurEnvTriggerSet("MZtunl2","Door01");
		if(VKeyObjTriggered==0)
		{
			float(_or,VarKey82,2);
			float(_set,TmpFloat,0x7f00);
		}
		else
		{
			float(_clr,VarKey82,2);
			float(_set,TmpFloat,0x7f0000);
		}

		CurEnvTriggerSet("MZtunl2","Door");
		call(expset1,1,TmpFloat,0);
		if(VKeyObjTriggered==0)
		{
			float(_or,VarKey82,1);
			float(_set,TmpFloat,0x7f00);
		}
		else
		{
			float(_clr,VarKey82,1);
			float(_set,TmpFloat,0x7f0000);
		}

		CurEnvTriggerSet("MZtunl2","Door01");
		call(expset1,1,TmpFloat,0);
	}

	if(VSetActive=="mz_04")
	{
		CurEnvTriggerSet("mz_04","BarLeft");
		call(CheckTriggerObjFlag,TmpFloat,0,_SXObjDynamicObj);
		if(TmpFloat==TRUE)
		{
			float(_or,VarKey81,16);
		}

		CurEnvTriggerSet("mz_04","BarRight");
		call(CheckTriggerObjFlag,TmpFloat,0,_SXObjDynamicObj);
		if(TmpFloat==TRUE)
		{
			float(_or,VarKey81,32);
		}
	}
	if(VSetActive=="mz_05")
	{
		CurEnvTriggerSet("mz_05","OverRide");
		call(CheckTriggerObjFlag,TmpFloat,1,_SXObjDynamicObj);
		if(TmpFloat==TRUE)
		{
			float(_or,VarKey81,64);
			call(ChangeTrigger,_set,_SXTrigPanel);
		}
		if(VarKey81&=1024)
		{
			CurEnvTriggerSet("Mz_05","TurretGo");
			if(VKeyObjTriggered==0)
			{
				CurEnvTriggerSet("Mz_05","OverRide");
				call(KeyObjTrigger,255,1);
				kfsample(SFXLiftStart,SFXLiftMove,-1,SFXLiftEnd);
				float(_clr,VarKey81,1024);
			}
		}
		elseif(VarKey81&=2048)
		{
			CurEnvTriggerSet("Mz_05","OverRide");
			if(VKeyObjTriggered==0)
			{
				CurEnvTriggerSet("Mz_05","TurretGo");
				call(KeyObjTrigger,0,-1);
				vector(_set,Gactorpos,-13187,24897,10201);
				Sample(SFXPneumatik,Gactorpos);
				float(_clr,VarKey81,2048);
			}
		}
	}


	if(VarKey81&=4096 && VCutScene==0)							//doesn't have to be in any set (for the bird/rat sequence)
	{
		Camera(BobRun_camera_distance,BobRun_camera_angle);
		Target(BobRun_camera_Tdistance,BobRun_camera_Tangle);
		float(_clr,VarKey81,4096);
	}

	if(VSetActive=="mz_hrzn1")
	{
		CurEnvTriggerSet("mz_hrzn1","ForceTrig");
		call(expset1,-1,-8,-1);
	}

	//	the sets below are meant to curset
	//
	elseif(VCurSet=="mz_08")									
	{
		if(timer>=0)
		{
			float(_sub,timer,1);
		}
		if(timer2>=0)
		{
			float(_sub,timer2,1);
		}

		if(timer==1)
		{
	 		CurEnvTrigger("LiftDown");
 			call(KeyObjTrigger,7,1);
			kfsample(SFXLiftStart,SFXLiftMove,-1,SFXLiftEnd);
		}
		elseif(timer2==1)
		{
			CurEnvTrigger("LiftDown");
			call(KeyObjTrigger,3,1);
			kfsample(SFXLiftStart,SFXLiftMove,-1,SFXLiftEnd);
		}

		if(VarKey82&=32)
		{
			float(_set,TmpFloat,0x7f00);
		}
		else
		{
			float(_Set,TmpFloat,0x7f0000);
		}
		CurEnvTrigger("Door");
		call(ExpSet1,1,TmpFloat,0);
	}
	elseif(VCurSet=="mz_01")
	{
		CurEnvTrigger("LiftGo");
		if(VarKey81&=8192)
		{
			if(VKeyObjTriggered==0)
			{
				callsub(Sub_SetCameraNormal);
				float(_clr,VarKey81,8192);
				
				CurEnvTrigger("liftdoors");
				callsub(DoorOpen,0,1);
			}
			else
			{
				Camera(elevator_camera_distance,elevator_camera_angle);
				Target(elevator_camera_Tdistance,elevator_camera_Tangle);
			}
		}
	}

	//	VARIABLES TO BE CLEARED EVERY FRAME
	//
	float(_clr,VarKey82,32);					//clear door can be opened in mz_08
	float(_clr,VarKey82,256);					//clear door can be opened in mz_02
	float(_clr,VarKey82,2048);					//clear door can be opened in mz_07
}



SubRoutine(Sub_RightGunHandler)
{
		if(VarKey85<0)
		{
			float(_add,VarKey85,1);
		}
		else
		{
			float(_set,TmpFloat,0);
			CurEnvTrigger("TurretGo");
			if(VTrigger==_DIREnvTrigger)
			{
				float(_set,TmpFloat,1);
			}

			if(VarKey85==2)
			{
				if(VarKey81&=32 || TmpFloat==0)
				{
					Direction(_or,_DIRaction);					//jump out of this in a second
				}
			}

			if(VTrigger==_DIRaction)
			{
				if(VarKey85==2)
				{
					Direction(_clr,_DIRaction);
					float(_set,VarKey85,-60);
					CurEnvTriggerSet("mz_04","TURRIGHT");
					call(ExpSet2,-1,0,0);					//turn expcamera off
				}
				elseif(TmpFloat==1)
				{
					if(VarKey81&=32)
					{
						Message("The gun has been blown to bits",300,10);
					}
					else
					{
						if(VAIClass==_AIclasscop && VRank==_RankCommander)
						{
							call(ActivateButton,"gun activated",-1,FALSE);
							call(ActivateButtonSample,SFXValidFunction);
							CurEnvTriggerSet("mz_04","TURRIGHT");
							CutScene("tcamright");
							call(ChangeCutScene,_SXCUTflag,_or,_SXCUTdontreset);
							call(ChangeCutScene,_SXCUTspeed,2000);
							float(_set,VarKey85,1);
							call(PlayerInput,0);
						}
						else
						{
							call(ActivateButton,"only guncommanders know how to operate this",-1,FALSE);
							call(ActivateButtonSample,SFXInvalidFunction);
						}
					}
					Direction(_clr,_DIRaction);
				}
			}
			else
			{
				if(VarKey85==1 && VCutScene==0)
				{
					float(_set,VarKey85,2);
					call(PlayerInput,1);
					float(_set,timer,15);
				}

				if(VarKey85==2)
				{
					CurEnvTriggerSet("mz_04","TURRIGHT");
					call(ExpSet2,4096,1,1);					//expcamera position, inf seconds, use exp1 for target
					call(KeyObjControl,_DIRleft,_DIRright,-1,-1,SFXGunTurretHorizontal);
					CurEnvTriggerSet("mz_04","BARRIGHT");
					call(KeyObjControl,_DIRbackward,_DIRforward,0,1,SFXGunTurretVertical);

					vector(_set,Gactorpos,-18,27,0);
					spawnparticle(fx_flare,-3,gactorpos,emptyvector,fx_coplaserflarered);

					vector(_set,Gactorine,0,0,-1024);
					spawnparticle(fx_coplaser,-3,gactorpos,gactorine,-1);

					if(VTrigger==_DIRshoot)
					{
						Direction(_clr,_DIRshoot);
						if(timer==15)
						{
							float(_set,timer,0);
							vector(_set,tmpvector,0,0,-160);
							SpawnActorKFObj(BulletBazooka,tmpvector,Gactorpos,Gactorine,true);
							spawnparticle(fx_TurFlash,-2,Gactorpos,Gactorine,fx_gunflashhorizac);
							spawnparticle(fx_TurFlash,-2,Gactorpos,Gactorine,fx_gunflashvertac);
							spawnparticle(fx_TurFlash,-2,Gactorpos,Gactorine,fx_gunflashdiag1ac);
							spawnparticle(fx_TurFlash,-2,Gactorpos,Gactorine,fx_gunflashdiag2ac);
						}
					}
					if(timer<15)
					{
						float(_add,timer,1);
					}
				}
			}
		}
}	

SubRoutine(Sub_LeftGunHandler)
{
		if(VarKey85<0)
		{
			float(_add,VarKey85,1);
		}
		else
		{
			float(_set,TmpFloat,0);
			CurEnvTrigger("TurretGo");
			if(VTrigger==_DIREnvTrigger)
			{
				float(_set,TmpFloat,1);
			}

			if(VarKey85==2)
			{
				if(VarKey81&=16 || TmpFloat==0)
				{
					Direction(_or,_DIRaction);					//jump out of this in a second
				}
			}

			if(VTrigger==_DIRaction)
			{
				if(VarKey85==2)
				{
					Direction(_clr,_DIRaction);
					float(_set,VarKey85,-60);
					CurEnvTriggerSet("mz_04","TURLEFT");
					call(ExpSet2,-1,0,0);					//turn expcamera off
				}
				elseif(TmpFloat==1)
				{
					Direction(_clr,_DIRaction);
					if(VarKey81&=16)
					{
						Message("The gun has been blown to bits",300,10);
					}
					else
					{
						if(VAIClass==_AIclasscop && VRank==_RankCommander)
						{
							call(ActivateButton,"gun activated",-1,FALSE);
							call(ActivateButtonSample,SFXValidFunction);
							CurEnvTriggerSet("mz_04","TURRIGHT");
							CutScene("tcamright");
							call(ChangeCutScene,_SXCUTflag,_or,_SXCUTdontreset);
							call(ChangeCutScene,_SXCUTspeed,2000);
							float(_set,VarKey85,1);
							call(PlayerInput,0);
						}
						else
						{
							call(ActivateButton,"only guncommanders know how to operate this",-1,FALSE);
							call(ActivateButtonSample,SFXInvalidFunction);
						}
					}
				}
			}
			else
			{
				if(VarKey85==1 && VCutScene==0)
				{
					float(_set,VarKey85,2);
					call(PlayerInput,1);
					float(_set,timer,15);
				}

				if(VarKey85==2)
				{
					CurEnvTriggerSet("mz_04","TURLEFT");
					call(ExpSet2,4096,1,1);					//expcamera position, inf seconds, use exp1 for target
					call(KeyObjControl,_DIRleft,_DIRright,-1,-1,SFXGunTurretHorizontal);
					CurEnvTriggerSet("mz_04","BARLEFT");
					call(KeyObjControl,_DIRbackward,_DIRforward,0,1,SFXGunTurretVertical);

					vector(_set,Gactorpos,-18,27,0);
					spawnparticle(fx_flare,-3,gactorpos,emptyvector,fx_coplaserflarered);

					vector(_set,Gactorine,0,0,-1024);
					spawnparticle(fx_coplaser,-3,gactorpos,gactorine,-1);

					if(VTrigger==_DIRshoot)
					{
						Direction(_clr,_DIRshoot);
						if(timer==15)
						{
							float(_set,timer,0);
							vector(_set,tmpvector,0,0,-160);
							SpawnActorKFObj(BulletBazooka,tmpvector,Gactorpos,Gactorine,true);
							spawnparticle(fx_TurFlash,-2,Gactorpos,Gactorine,fx_gunflashhorizac);
							spawnparticle(fx_TurFlash,-2,Gactorpos,Gactorine,fx_gunflashvertac);
							spawnparticle(fx_TurFlash,-2,Gactorpos,Gactorine,fx_gunflashdiag1ac);
							spawnparticle(fx_TurFlash,-2,Gactorpos,Gactorine,fx_gunflashdiag2ac);
						}
					}
					if(timer<15)
					{
						float(_add,timer,1);
					}
				}
			}
		}
}

SubRoutine(BackgroundTriggerChecksScene17)
{
	if(VCurSet=="Mz_01")							//are we in the right set?
	{
		CurEnvTrigger("LiftGo");
		if(VTrigger==_DIREnvTrigger && VKeyObjTriggered==0)
		{
			call(KeyOBjTrigger,255,1);
			kfsample(SFXLiftStart,SFXLiftMove,-1,SFXLiftEnd);
			float(_or,VarKey81,8192);
		}
	}
	elseif(VCurSet=="Mz_02")							//are we in the right set?
	{
		if(VarKey81&!=1)							//has sequence already been executed?
		{
			if(VAICon==0)							//only interested in non-AI players
			{
				CurEnvTrigger("BirdView");			//set the trigger to check
				if(VTrigger==_DIREnvTrigger)		//did we cross the planetrigger?
				{
					float(_or,VarKey81,3);			//mark sequence as started
					call(PlayerInput,0);			//player is going to stand and watch for a while, so disable input
					vector(_set,Gactorpos,-5980,25447,7804);
					vector(_set,Gactorangle,0,2048,0);
					InitActor(Bird,Gactorpos,Gactorangle,"Mz_02",TRUE,1);
					CutScene("MungSucker");
				}
			}
		}
		elseif(VarKey81&=2)
		{
			if(VCutScene==0)
			{
				if(VAICon==0)
				{
					call(PlayerInput,1);
					float(_clr,VarKey81,2);		//VERY risky, assuming playerone is last in actorlist
				}
				elseif(VAIClass==_AIclassanimal)
				{
					KillActor();
				}
			}
		}

		CurEnvTrigger("Door01");
		if(VKeyObjTriggered==0 && VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)
		{
			callsub(DoorOpen,1,1);
		}

		CurEnvTrigger("Door");
		if(VTrigger==_DIREnvTrigger)
		{
			if(VAIClass==_AIclassabeast)
			{
				float(_or,VarKey82,256);
				if(VTrigger==_DIRaction)
				{
					callsub(DoorOpen,2,1);
				}
			}
			elseif(VAICon==0 && VTrigger==_DIRaction)
			{
				Message("I need something heavy for this pressure plate",300,10);
			}
		}

		if(VarKey81&=256 && VAIClass==_AIclassAnimal && VRank==_RankSergeantM)			//bird
		{
			CurEnvTrigger("BIRDTHRU");
			if(VTrigger==_DIREnvTrigger)
			{
				call(SetTriggerObjFlag,1,_or,_SXObjCollisionOff);
				call(SetTriggerObjFlag,2,_or,_SXObjCollisionOff);
			}
		}
	}
	elseif(VCurSet=="Mztunl1")
	{
		if(VTrigger==_DIRaction)
		{
			CurEnvTrigger("Door01");
			if(VKeyObjTriggered==0 && VTrigger==_DIREnvTrigger)
			{
				if(VarKey82&=1)
				{
					callsub(DoorOpen,1,1);
				}
				else
				{
					Message("Wait for it",300,10);
				}
			}

			CurEnvTrigger("Door");
			if(VKeyObjTriggered==0 && VTrigger==_DIREnvTrigger)
			{
				if(VarKey82&=2)
				{
					callsub(DoorOpen,1,1);
				}
				else
				{
					Message("Wait for it",300,10);
				}
			}

			CurEnvTrigger("arme");
			if(VTrigger==_DIREnvTrigger)
			{
				if(VClass!=_ClassAngel)
				{
					if(VKeyObjFrame==0 && VKeyObjTriggered==0)
					{
						call(ActivateButton,"Weapon Dispenser Activated",-1,FALSE);
						call(ActivateButtonSample,SFXValidFunction);
						vector(_set,Gactorpos,-8078,24484,10796);
						vector(_set,Gactorangle,0,0,0);
						InitActor(WeaponMachineGun,Gactorpos,Gactorangle,"Mztunl1",TRUE);
						call(KeyObjTrigger,255,1);
						float(_set,TmpFloat,0x0000ff);
						call(expset1,1,TmpFloat,0);
					}
					elseif(VAICON==0)
					{
						call(ActivateButton,"Weapon Dispenser Already Activated",-1,FALSE);
						call(ActivateButtonSample,SFXInvalidFunction);
					}
				}
				elseif(VAICON==0)
				{
					call(ActivateButton,"I wish I could operate that thing !",-1,FALSE);
					call(ActivateButtonSample,SFXInvalidFunction);
				}
			}

			CurEnvTrigger("arme1");
			if(VTrigger==_DIREnvTrigger)
			{
				if(VClass!=_ClassAngel)
				{
					if(VKeyObjFrame==0 && VKeyObjTriggered==0)
					{
						call(ActivateButton,"Weapon Dispenser Activated",-1,FALSE);
						call(ActivateButtonSample,SFXValidFunction);
						vector(_set,Gactorpos,-7789,24484,10780);
						vector(_set,Gactorangle,0,0,0);
						InitActor(WeaponFlameThrower,Gactorpos,Gactorangle,"Mztunl1",TRUE);
						call(KeyObjTrigger,255,1);
						float(_set,TmpFloat,0x0000ff);
						call(expset1,1,TmpFloat,0);
					}
					elseif(VAICON==0)
					{
						call(ActivateButton,"Weapon Dispenser Already Activated",-1,FALSE);
						call(ActivateButtonSample,SFXInvalidFunction);
					}
				}
 				elseif(VAICON==0)
				{
					call(ActivateButton,"I wish I could operate that thing !",-1,FALSE);
					call(ActivateButtonSample,SFXInvalidFunction);
				}
			}
		}
	}
	elseif(VCurSet=="MZ_03")
	{
		if(VTrigger==_DIRAction)
		{
			CurEnvTrigger("OverRide");
			if(VTrigger==_DIREnvTrigger && VKeyObjTriggered==0 && VKeyObjFrame==0)
			{
				call(ActivateButton,"Lift called",-1,FALSE);
				call(ActivateButtonSample,SFXValidFunction);
				CurEnvTrigger("TurretGo");
				call(KeyObjTrigger,255,1);
				vector(_set,Gactorpos,-8687,24897,10201);
				Sample(SFXPneumatik,Gactorpos);
				Direction(_clr,_DIRaction);
				float(_or,VarKey81,4);
				CurEnvTrigger("PltFrmUp");
				call(ChangeTrigger,_set,_SXTrigPanel);
			}

			CurEnvTrigger("Door");
			if(VTrigger==_DIREnvTrigger)
			{
				callsub(DoorOpen,1,1);
				Direction(_clr,_DIRaction);
			}
		}

		CurEnvTrigger("OverRide");
		if(VKeyObjTriggered==0)
		{
			if(VTrigger==_DIRaction)
			{
				if(VKeyObjFrame==2)						//elevator up
				{
					CurEnvTrigger("PLTFRMUP");
					if(VTrigger==_DIREnvTrigger)
					{
						CurEnvTrigger("OverRide");
						call(ActivateButton,"Engaging gun controls",-1,FALSE);
						call(ActivateButtonSample,SFXValidFunction);
						call(KeyObjTrigger,0,-1);
						kfsample(SFXLiftStart,SFXLiftMove,-1,SFXLiftEnd);
						Direction(_clr,_DIRaction);
						float(_or,VarKey81,8);
					}
				}
				elseif(VKeyObjFrame==0)
				{
					CurEnvTrigger("PLTFRMDWN");
					if(VTrigger==_DIREnvTrigger)
					{
						CurEnvTrigger("TurretGo");
						call(ActivateButton,"Disengaging gun controls",-1,FALSE);
						call(ActivateButtonSample,SFXValidFunction);
						call(KeyObjTrigger,255,1);
						vector(_set,Gactorpos,-8687,24897,10201);
						Sample(SFXPneumatik,Gactorpos);
						Direction(_clr,_DIRaction);
						float(_or,VarKey81,4);
					}
				}
			}
		}

		if(VAICon==0)
		{
			callsub(Sub_LeftGunHandler);
		}
	}
	elseif(VCurSet=="mz_05")
	{
		if(VTrigger==_DIRAction)				//panel has been shot
		{
			if(VarKey81&=64)
			{
				CurEnvTrigger("OverRide");
				if(VTrigger==_DIREnvTrigger && VKeyObjTriggered==0 && VKeyObjFrame==0)
				{
					call(ActivateButton,"Lift called",-1,FALSE);
					call(ActivateButtonSample,SFXValidFunction);
					CurEnvTrigger("TurretGo");
					call(KeyObjTrigger,255,1);
					vector(_set,Gactorpos,-13187,24897,10201);
					Sample(SFXPneumatik,Gactorpos);
					Direction(_clr,_DIRaction);
					float(_or,VarKey81,1024);

					CurEnvTrigger("PltFrmUpF");
					call(ChangeTrigger,_set,_SXTrigPanel);
				}
			}

			CurEnvTrigger("Door");
			if(VTrigger==_DIREnvTrigger)
			{
				callsub(DoorOpen,1,1);
			}
		}

		CurEnvTrigger("OverRide");
		if(VKeyObjTriggered==0)
		{
			if(VTrigger==_DIRaction)
			{
				if(VKeyObjFrame==2)						//elevator up
				{
					CurEnvTrigger("PLTFRMUPF");
					if(VTrigger==_DIREnvTrigger)
					{
						CurEnvTrigger("OverRide");
						call(ActivateButton,"Engaging gun controls",-1,FALSE);
						call(ActivateButtonSample,SFXValidFunction);
						call(KeyObjTrigger,0,-1);
						kfsample(SFXLiftStart,SFXLiftMove,-1,SFXLiftEnd);
						Direction(_clr,_DIRaction);
						float(_or,VarKey81,2048);
					}
				}
				elseif(VKeyObjFrame==0)
				{
					CurEnvTrigger("PLTFRMDWN");
					if(VTrigger==_DIREnvTrigger)
					{
						CurEnvTrigger("TurretGo");
						call(ActivateButton,"Disengaging gun controls",-1,FALSE);
						call(ActivateButtonSample,SFXValidFunction);
						call(KeyObjTrigger,255,1);
						vector(_set,Gactorpos,-13187,24897,10201);
						Sample(SFXPneumatik,Gactorpos);
						Direction(_clr,_DIRaction);
						float(_or,VarKey81,1024);
					}
				}
			}
		}

		if(VAICon==0)
		{
			callsub(Sub_RightGunHandler);
		}
	}
	elseif(VCurSet=="Mz_07")
	{
		CurEnvTrigger("Door");
		if(VTrigger==_DIREnvTrigger)
		{
			if(VAIClass==_AIclassabeast)
			{
				float(_or,VarKey82,2048);
				if(VTrigger==_DIRaction)
				{
					callsub(DoorOpen,2,1);
				}
			}
			elseif(VAICon==0 && VTrigger==_DIRaction)
			{
				Message("I need something heavy for this pressure plate",300,10);
			}
		}
	}
	elseif(VCurSet=="Mztunl2")
	{
		if(VTrigger==_DIRaction)
		{
			CurEnvTrigger("Door01");
			if(VKeyObjTriggered==0 && VTrigger==_DIREnvTrigger)
			{
				if(VarKey82&=1)
				{
					callsub(DoorOpen,1,1);
				}
				else
				{
					Message("Wait for it",300,10);
				}
			}

			CurEnvTrigger("Door");
			if(VKeyObjTriggered==0 && VTrigger==_DIREnvTrigger)
			{
				if(VarKey82&=2)
				{
					callsub(DoorOpen,1,1);
				}
				else
				{
					Message("Wait for it",300,10);
				}
			}

			CurEnvTrigger("arme");
			if(VTrigger==_DIREnvTrigger)
			{
				if(VClass!=_ClassAngel)
				{
					if(VKeyObjFrame==0 && VKeyObjTriggered==0)
					{
						call(ActivateButton,"Weapon Dispenser Activated",-1,FALSE);
						call(ActivateButtonSample,SFXValidFunction);
						vector(_set,Gactorpos,-14087,24484,10796);
						vector(_set,Gactorangle,0,0,0);
						InitActor(WeaponMachineGun,Gactorpos,Gactorangle,"Mztunl2",TRUE);
						call(KeyObjTrigger,255,1);
						float(_set,TmpFloat,0x0000ff);
						call(expset1,1,TmpFloat,0);
					}
					elseif(VAICON==0)
					{
						call(ActivateButton,"Weapon Dispenser Already Activated",-1,FALSE);
						call(ActivateButtonSample,SFXInvalidFunction);
					}
				}
				elseif(VAICON==0)
				{
					call(ActivateButton,"I wish I could operate that thing !",-1,FALSE);
					call(ActivateButtonSample,SFXInvalidFunction);
				}
			}

			
			CurEnvTrigger("arme1");
			if(VTrigger==_DIREnvTrigger)
			{
				if(VClass!=_ClassAngel)
				{
					if(VKeyObjFrame==0 && VKeyObjTriggered==0)
					{
						call(ActivateButton,"Weapon Dispenser Activated",-1,FALSE);
						call(ActivateButtonSample,SFXValidFunction);
						vector(_set,Gactorpos,-13787,24484,10780);
						vector(_set,Gactorangle,0,0,0);
						InitActor(WeaponPumpGun,Gactorpos,Gactorangle,"Mztunl2",TRUE);
						call(KeyObjTrigger,255,1);
						float(_set,TmpFloat,0x0000ff);
						call(expset1,1,TmpFloat,0);
					}
					elseif(VAICON==0)
					{
						call(ActivateButton,"Weapon Dispenser Already Activated",-1,FALSE);
						call(ActivateButtonSample,SFXInvalidFunction);
					}
				}
 				elseif(VAICON==0)
				{
					call(ActivateButton,"I wish I could operate that thing !",-1,FALSE);
					call(ActivateButtonSample,SFXInvalidFunction);
				}
			}
		}
	}
	elseif(VCurSet=="mz_06")
	{
		if(VTrigger==_DIRAction)				//panel has been shot
		{
			CurEnvTrigger("Door");
			if(VTrigger==_DIRaction)
			{
				callsub(DoorOpen,1,1);
			}
		}
	}
	elseif(VCurSet=="mz_08a")
	{
		if(VarKey81&!=512)
		{
			CurEnvTrigger("RatTrig");
			if(VTrigger==_DIREnvTrigger)
			{
				if(VAICon==0 && VAIClass==_AIclassanimal && VRank==_RankSergeantL)		//only if player is a rat
				{
					call(PlayerInput,1);
					FirstPerson(1);
					float(_or,VarKey81,512);
					float(_set,timer,0);
					float(_set,timer2,0);
				}
			}
		}
	}
	elseif(VCurSet=="mz_09")
	{
		if(VarKey81&!=256)
		{
			if(VAICon==0 && VAIClass==_AIclassAnimal)
			{
				CurEnvTrigger("RatTrig");
				if(VTrigger==_DIREnvTrigger)
				{
					call(PlayerInput,0);		//uncomment later
					vector(_set,Gactorpos,-14984,25046,8318);
					vector(_set,Gactorangle,0,2048,0);
					InitActor(Bird,Gactorpos,Gactorangle,"Mz_09",TRUE,3);
					float(_or,VarKey81,128);
					CutScene("BirdView");
					call(ChangeCutScene,_SXCUTflag,_or,_SXCUTdontreset);
					FirstPerson(0);

					vector(_settotriggerpos,tmpvector);
					vector(_settoactorpos,tmpvector2);
					vector(_sub,tmpvector,tmpvector2);
					vector(_copyx,tmpvector,tmpfloat);
					vector(_copyy,tmpvector,tmpfloat2);
					vector(_copyz,tmpvector,tmpfloat3);
					move(tmpfloat,tmpfloat2,tmpfloat3);
				}
			}
			if(VarKey81&=128)
			{
				if(VAIClass==_AIclassAnimal && VRank==_RankSergeantM)			//bird
				{
					call(AIfindpathwithspecificid,3);
					float(_or,VarKey81,256);
					float(_or,VarKey81,4096);
				}
			}
		}
	}
	elseif(VCurSet=="mz_08")
	{
		if(VTrigger==_DIRaction)
		{
			CurEnvTrigger("B_LOCK01");
			if(VTrigger==_DIREnvTrigger)
			{
				if(VarKey82&=4)
				{
					Message("Armored Behemoth already activated",300,10);
				}
				else
				{
					call(ActivateButton,"Armored Behemoth activated",-1,FALSE);
					call(ActivateButtonSample,SFXValidFunction);
					call(KeyObjTrigger,255,1);
					float(_set,TmpFloat,0x7f0000);
					call(expset1,1,TmpFloat,0);
					float(_or,VarKey82,4);
					CutScene("BeastCam");
					call(ChangeCutScene,_SXCUTspeed,150);
					call(ChangeCutScene,_SXCUTflag,_or,_SXCUTnosmooth);
				}
			}

			CurEnvTrigger("B_LOCK02");
			if(VTrigger==_DIREnvTrigger)
			{
				if(VarKey82&=8)
				{
					Message("Armored Behemoth already activated",300,10);
				}
				else
				{
					call(ActivateButton,"Armored Behemoth activated",-1,FALSE);
					call(ActivateButtonSample,SFXValidFunction);
					call(KeyObjTrigger,255,1);
					float(_set,TmpFloat,0x7f0000);
					call(expset1,1,TmpFloat,0);
					float(_or,VarKey82,8);
					CutScene("BeastCam");
					call(ChangeCutScene,_SXCUTspeed,150);
					call(ChangeCutScene,_SXCUTflag,_or,_SXCUTnosmooth);
				}
			}

			CurEnvTrigger("B_LOCK03");
			if(VTrigger==_DIREnvTrigger)
			{
				if(VarKey82&=16)
				{
					Message("Armored Behemoth already activated",300,10);
				}
				else
				{
					call(ActivateButton,"Armored Behemoth activated",-1,FALSE);
					call(ActivateButtonSample,SFXValidFunction);
					call(KeyObjTrigger,255,1);
					float(_set,TmpFloat,0x7f0000);
					call(expset1,1,TmpFloat,0);
					float(_or,VarKey82,16);
					CutScene("BeastCam");
					call(ChangeCutScene,_SXCUTspeed,150);
					call(ChangeCutScene,_SXCUTflag,_or,_SXCUTnosmooth);
				}
			}
		}

		if(VAICon!=0 && VAIClass==_AIclassabeast)
		{
			CurEnvTrigger("ShutDown1");
			if(VTrigger==_DIREnvTrigger)
			{
				if(VarKey82&=4)
				{
					if(VCutScene!=0 && VCutSceneFrameEqual==3 && VActorFlag==_AFLAGnoai)
					{
						ActorFlag(_clr,_AFLAGnoai);
						vector(_set,gactorpos,-5984, 24580, 7426);		//beast 1
						samplestop(SFXBreathing,gactorpos);
						call(KeyObjTrigger,255,1);
						Sample(SFXLatch2,-1);
					}
				}
				else
				{
					ActorFlag(_or,_AFLAGnoai);
				}
			}

			CurEnvTrigger("ShutDown2");
			if(VTrigger==_DIREnvTrigger)
			{
				if(VarKey82&=8)
				{
					if(VCutScene!=0 && VCutSceneFrameEqual==3 && VActorFlag==_AFLAGnoai)
					{
						ActorFlag(_clr,_AFLAGnoai);
						vector(_set,gactorpos,-5687, 24580, 7426);		//beast 2
						samplestop(SFXBreathing,gactorpos);
						call(KeyObjTrigger,255,1);
						Sample(SFXLatch2,-1);
					}
				}
				else
				{
					ActorFlag(_or,_AFLAGnoai);
				}
			}

			CurEnvTrigger("ShutDown3");
			if(VTrigger==_DIREnvTrigger)
			{
				if(VarKey82&=16)
				{
					if(VCutScene!=0 && VCutSceneFrameEqual==3 && VActorFlag==_AFLAGnoai)
					{
						ActorFlag(_clr,_AFLAGnoai);
						vector(_set,gactorpos,-5984, 24580, 6379);		//beast 3
						samplestop(SFXBreathing,gactorpos);
						call(KeyObjTrigger,255,1);
						Sample(SFXLatch2,-1);
					}
				}
				else
				{
					ActorFlag(_or,_AFLAGnoai);
				}
			}
		}

		float(_set,TmpFloat,0);
		CurEnvTrigger("LiftLow01");
		if(VTrigger==_DIREnvTrigger)
		{
			float(_or,TmpFloat,1);
		}
		CurEnvTrigger("LiftLow02");
		if(VTrigger==_DIREnvTrigger)
		{
			float(_or,TmpFloat,1);
		}
		CurEnvTrigger("LiftLow03");
		if(VTrigger==_DIREnvTrigger)
		{
			float(_or,TmpFloat,1);
		}
		CurEnvTrigger("LiftUp01");
		if(VTrigger==_DIREnvTrigger)
		{
			float(_or,TmpFloat,2);
		}
		CurEnvTrigger("LiftUp02");
		if(VTrigger==_DIREnvTrigger)
		{
			float(_or,TmpFloat,2);
		}
		CurEnvTrigger("LiftUp03");
		if(VTrigger==_DIREnvTrigger)
		{
			float(_or,TmpFloat,2);
		}

 		CurEnvTrigger("LiftDown");
		if(VKeyObjTriggered==0)
		{
			if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)
			{
				if(VKeyObjFrame==0)
				{
					call(ActivateButton,"Lift called",-1,FALSE);
					call(KeyObjTrigger,3,1);
					kfsample(SFXLiftStart,SFXLiftMove,-1,SFXLiftEnd);
				}
				else
				{
					Message("Lift has been called",300,10);
				}
			}
			if(TmpFloat&=1 && VKeyObjFrame==3)
			{
				float(_set,timer,30);
			}
			elseif(TmpFloat&=2 && VKeyObjFrame==0)
			{
				float(_set,timer2,30);
			}
		}
		elseif(VKeyObjFrame<1)
		{
			if(TmpFloat&=1)
			{
				Message("Hazard! Elevator sequence aborted",300,10);
				call(KeyObjTrigger,0,-1);
			}
		}

		CurEnvTrigger("Door");
		if(VTrigger==_DIREnvTrigger)
		{
			if(VAIClass!=_AIclassabeast)
			{
				if(VAICon==0 && VTrigger==_DIRaction)
				{
					Message("I need something heavy for this pressure plate",300,10);
				}
			}
			else
			{
				float(_or,VarKey82,32);
				if(VTrigger==_DIRaction)
				{
					callsub(DoorOpen,2,1);
				}
			}
		}
	}
	elseif(VCurSet=="mz_10")
	{
		CurEnvTrigger("Door");
		if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)
		{
			callsub(DoorOpen,2,1);
		}

		if(VAICon!=0)
		{
			if(VarKey82&=512 && VAIClass==_AIclassabeast)
			{
				float(_clr,VarKey82,512);					//don't be pissed again
				call(AIchangemetoenemy);
			}
		}
		else
		{
			if(VarKey82&!=1024)
			{
				CurEnvTrigger("BstFight");
				if(VTrigger==_DIREnvTrigger)
				{
					float(_or,VarKey82,512);				//tell abeast to get pissed
					float(_or,VarKey82,1024);				//don't trigger get pissed again
				}
			}
		}
	}
	///////////////////
	// TELEPORTATION //
	///////////////////

	//Wait for WallBulb EXP (right now, it spawns a "distort" bullet
	//from PlayerOne - Placeholder)
	
	elseif(VCurSet=="mz_11")
	{
		if(VAICon==0)
		{
			CurEnvTrigger("tele");
			if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)
			{
				call(PlayerInput,0);
				call(GodModeStatus,true);
				call(ExpSet2,800,1,1);
				float(_or,VarKey82,4096);
				float(_set,timer2,0);
			}

			if(VarKey82&=4096)
			{	
				float(_add,timer2,1);
				if(timer2<=800 && Timer2>=50)
				{
					float(_add,timer3,1);
					if(timer3==5)
					{
						vector(_set,TmpVector,0,0,0);
						spawnactorbone(BulletDistortStraight,TmpVector,Gactorpos,Gactorine,1);
					}
					if(timer3==50)
					{
						vector(_set,TmpVector,0,0,0);
						spawnactorbone(BulletDistortStraight,TmpVector,Gactorpos,Gactorine,4);
					}
					if(timer3==85)
					{
						vector(_set,TmpVector,0,0,0);
						spawnactorbone(BulletDistortStraight,TmpVector,Gactorpos,Gactorine,8);
					}
					if(timer3==115)
					{
						vector(_set,TmpVector,0,0,0);
						spawnactorbone(BulletDistortStraight,TmpVector,Gactorpos,Gactorine,12);
					}
					if(timer3==150)
					{
						vector(_set,TmpVector,0,0,0);
						spawnactorbone(BulletDistortStraight,TmpVector,Gactorpos,Gactorine,4);
					}
					if(timer3>=160)
					{
						float(_set,timer3,0);
					}
				}
				if(timer2==600)
				{
					call(FadeToBlack);
				}
				if(timer2==801)
				{
					SetActorToTrigger("mz_11","program");
				}
			}
		}		
	}
}