//////////////////////////////////
///		CITY ONE - SECTOR 2	   ///
//////////////////////////////////
// This script has to be merged with Scene2.hxx for final version
//

//VarKey11	-	Lift in S2r15
//VarKey12	-	Lift 2 in S2r15
//VarKey13	-	S2r2 sequence (dweller & Cop)
//				0     : Sequence has not been initialized
//				1     : Sequence has started
//				2->14 : Executes sequence
//VarKey14	-	Turret Control in s2r27
//VarKey15	-   Barrel Control in s2r27
//VarKey16	-	Check if a cop has been killed in S2r1
//VarKey17	-	Pod/Victim control in s2r15
//VarKey18	-   Activate Bot in s2r19
//VarKey19	-	Grinder sequence in S12R11
//timer		-	Used to time the Chot appearance in S2r2

//MissionLevel4	- InScan check

//VarBit01
//------
//
//Help01	>	grinder ctrl #1 in s2r11
//Help02	>	grinder ctrl #2 in s2r11
//Help03	>	flc ctrl in s2r11
//Help04	>	press ctrl in s2r11
//Help05	>	----- UNUSED -----
//Help06	>	----- UNUSED -----
//Help07	>	----- UNUSED -----
//Help08	>	----- UNUSED -----
//Help09	>	----- UNUSED -----
//Help10	>	----- UNUSED -----
//Help11	>	----- UNUSED -----
//Help12	>	----- UNUSED -----
//Help13	>	----- UNUSED -----
//Help14	>	----- UNUSED -----
//Help15	>	----- UNUSED -----
//Help16	>	----- UNUSED -----
//Help17	>	----- UNUSED -----
//Help18	>	----- UNUSED -----
//Help19	>	----- UNUSED -----
//Help20	>	----- UNUSED -----
//Help21	>	----- UNUSED -----
//Help22	>	----- UNUSED -----
//Help23	>	----- UNUSED -----
//Help24	>	----- UNUSED -----
//
//
//HelpVaR
//-------
//
//Help07	>	Defense Bot
//Help08	>	Companion Bot
//Help09	>	Gun Turret

SubRoutine(InitSceneSound3)
{
}

SubRoutine(InitScene3)
{
		InitActor(Bob1,0,Gactorangle,"war_03");

			// Reset all the variables
			float(_set,VarKey11,0);
			float(_set,VarKey12,0);
			float(_set,VarKey13,0);
			float(_set,VarKey14,0);
			float(_set,VarKey15,0);
			float(_set,VarKey16,0);
			float(_set,VarKey17,0);
			float(_set,VarKey18,0);
			float(_set,VarKey19,0);
			float(_set,VarKey20,0);
			float(_set,MissionLevel1,0);
			float(_set,MissionLevel2,0);
			float(_set,MissionLevel3,0);
			float(_set,MissionLevel4,0);
			float(_set,timer,0);
			float(_set,timer2,0);
			float(_set,timer3,0);
			float(_set,timer4,0);
			float(_set,side,0);
			float(_set,HelpVar,AllHelp);
			float(_set,VarBit,AllHelp);
			float(_set,VarBit01,AllHelp);
			float(_set,GunSmoke,0);
			float(_set,GunSamFlag,0);

			//enemy file
			#include "messiahscripts\enemies\c1_sector2.spt"

			callsub(InitSceneSound3);
}

SubRoutine(ScanCheck,const(AIClassCompare),const(RankCompare))
{
	if(VAICon==0)
	{
		if(VTrigger==_DIREnvTrigger)
		{
			if(InScan==-1)
			{
				if(VAIClass|=AIClassCompare && VRank>=RankCompare)
				{
					float(_set,AccessGranted,1);
				}
				else
				{
					if(AIClassCompare==_AIClassCop && RankCompare==_RankCommander)
					{
						message("Access Restricted To Commanders.",120,10);
						sample(SFXAccessDenied,Gactorpos);
					}
					elseif(AIClassCompare==_AIClassScientist && RankCompare==_RankScum)
					{
						message("Access Restricted To Radiation Workers.",120,10);
						sample(SFXAccessDenied,Gactorpos);
					}
					float(_set,AccessGranted,0);
				}
			}
			float(_set,InScan,1);
		}
		else
		{
			float(_set,Inscan,-1);
			float(_set,AccessGranted,0);
		}
	}
	if(InScan==1)
	{
		if(AccessGranted!=2)
		{
			float(_add,MissionLevel4,1)
			if(MissionLevel4<=3)
			{
				float(_set,TmpFloat,0xeeeeee);
				call(expset1,1,TmpFloat,0);
			}
			if(MissionLevel4>3)
			{
				float(_set,TmpFloat,0x020202);
				call(expset1,1,TmpFloat,0);
			}
			if(MissionLevel4>6)
			{
				float(_set,MissionLevel4,0);
			}
		}
	}
	if(InScan==-1)
	{
			float(_set,TmpFloat,0x020202);
			call(expset1,1,TmpFloat,0);
	}
}

SubRoutine(MainScene3)
{
	if(VSetActive=="s2r13")
	{
		CurEnvTriggerSet("s2r13","killme");
		call(ExpSet1,-10,0,0);
	}
	if(VCurSet=="s2r15")
	{
		//************ Particles for experiment in s2r15 **************
		if(MissionLevel1==9)
		{
			if(VarKey17==1)
			{
				vector(_set,Gactorpos,8758,658,10152);
			}
			elseif(VarKey17==2)
			{
				vector(_set,Gactorpos,8911,684,9848);
			}
			elseif(VarKey17==3)
			{
				vector(_set,Gactorpos,8010,684,9858);
			}
			elseif(VarKey17==4)
			{	
				vector(_set,Gactorpos,8171,658,10144);
			}
			float(_add,timer2,1);
			if(timer2==1)
			{
				vector(_set,tmpvector,180,180,65);
				spawnlight(LightPulseOmni2,-1,Gactorpos,tmpvector,EmptyVector,200);
			}
			if(timer2>=100)
			{
				float(_set,timer2,0);
			}

			if(vrnd<20)
			{
				vector(_set,Gactorine,0,10,0);
				SpawnParticle(fx_steam,-1,Gactorpos,Gactorine,-1);
				vector(_set,Gactorine,0,10,5);
				SpawnParticle(fx_steam,-1,Gactorpos,Gactorine,-1);
				vector(_set,Gactorine,0,10,-5);
				SpawnParticle(fx_steam,-1,Gactorpos,Gactorine,-1);
				vector(_set,Gactorine,5,10,0);
				SpawnParticle(fx_steam,-1,Gactorpos,Gactorine,-1);
				vector(_set,Gactorine,-5,10,0);
				SpawnParticle(fx_steam,-1,Gactorpos,Gactorine,-1);	
			}

			//********** Random lasers ******************
			vector(_set,fxvector,0,312,0);
			float(_rnd,TmpFloat,70);
			float(_rnd,TmpFloat1,70);
			vector(_addz,Gactorpos,TmpFloat);
			vector(_addx,Gactorpos,TmpFloat1);
			vector(_copy,Gactorine,Gactorpos);
			vector(_add,Gactorine,fxvector);
			callsub(LaserStrip,gactorpos,gactorine,fx_yellow,1);
			callsub(LaserStrip,gactorpos,gactorine,fx_yellowx,1);
		}
		if(MissionLevel1>=10 && MissionLevel1<=12)
		{
			float(_add,timer2,1);
			if(VarKey17==1)
			{
				vector(_set,Gactorpos,8758,750,10152);
			}
			if(VarKey17==2)
			{
				vector(_set,Gactorpos,8911,750,9848);
			}
			if(VarKey17==3)
			{
				vector(_set,Gactorpos,8018,750,9853);
			}
			if(VarKey17==4)
			{	
				vector(_set,Gactorpos,8171,750,10144);
			}
			vector(_set,TmpVector,0,5,0);
			if(timer2<=200)
			{
				/*
				Spawn3DFlare(220,180,10,200,Gactorpos,emptyvector); //MSIKA'S CRAP ...DOESN'T WORK!!!
																		
				*/
				spawnparticle(fx_evilfire,-1,gactorpos,emptyvector,fx_antirotate8);
				vector(_add,Gactorpos,TmpVector);
				spawnparticle(fx_evilfire,-1,gactorpos,emptyvector,fx_antirotate8);
				vector(_add,Gactorpos,TmpVector);
				spawnparticle(fx_evilfire,-1,gactorpos,emptyvector,fx_antirotate8);
				vector(_add,Gactorpos,TmpVector);
				spawnparticle(fx_evilfire,-1,gactorpos,emptyvector,fx_antirotate8);
			}
			if(timer2>=150)
			{
				float(_set,MissionLevel1,11);
			}
			if(timer2>=250)
			{
				float(_set,MissionLevel1,13);
			}
		}				
	}
	elseif(VCurSet=="s2r11")
	{
		if(VarKey19==0)
		{
			float(_set,VarKey19,1);
		}

		//******* Grinder rotates all the time **********
		if(VarBit01&=Help01)
		{
			CurEnvTrigger("grinder");
			if(VKeyObjTriggered==0)
			{
				call(KeyObjTrigger,255,1);
			}
		}
		//********** The grinder explodes **************
		if(VarBit01&!=Help01 && VarBit01&=Help02)
		{
			float(_add,timer3,1);
			if(timer3<=30)
			{
				//*************  Big Explosion *************
				if(vrnd<8)
				{
					vector(_set,TmpVector,10,0,0);
					vector(_set,Gactorpos,3959,490,9385);
					spawnparticle(fx_mainexplosion,-1,gactorpos,emptyvector,fx_antirotate8);
					spawnlight(flash_light,-1,Gactorpos,tmpvector,EmptyVector,500);
				}
			}
			elseif(timer3<=200)
			{
				//************* Sparks ******************
				if(vrnd<20)
				{
					vector(_set,tmpvector,0,0,0);
					float(_rnd2,tmpfloat,48);
					float(_sub,tmpfloat,24);
					vector(_setx,tmpvector,tmpfloat);
					float(_rnd2,tmpfloat,48);
					float(_sub,tmpfloat,24);
					vector(_sety,tmpvector,tmpfloat);
					float(_rnd2,tmpfloat,48);
					float(_sub,tmpfloat,24);
					vector(_setz,tmpvector,tmpfloat);
					vector(_set,Gactorpos,3851,582,9459);
					vector(_add,gactorpos,tmpvector);
					SpawnParticle(fx_sparks,-1,Gactorpos,EmptyVector,-1);
					vector(_set,tmpvector,20,150,250);
					spawnlight(flash_light,-1,Gactorpos,tmpvector,EmptyVector,300);
				}
			}
			elseif(timer3>=250)
			{
				//************* Plane collision is back on **************
				call(SetTriggerObjFlag,1,_clr,_SXObjCollisionOff);
				float(_set,timer3,0);
				float(_clr,VarBit01,Help02);
			}
		}
		 //********* Smoke that will remain all the time after explosion ************
		if(VarBit01&!=Help02)
		{
			if(vrnd<20)
			{
				vector(_set,Gactorpos,3959,593,9447);
				vector(_set,gactorine,0,12,0);
				spawnparticle(fx_fagsmoke,-1,gactorpos,gactorine,-1);
			}
		}
					
		//******* When crate on the lift, switch crates (invisible) **********
		CurEnvTrigger("barrel01");
		if(VKeyObjFrame==0 && VKeyObjTriggered==0)
		{
			float(_or,VarBit01,Help03);
			float(_or,VarBit01,Help04);
		}
		if(VKeyObjFrame==24 && VarBit01&=Help04)
		{
			CurEnvTrigger("grinder");
			call(expset2,0,49,49);
			float(_clr,VarBit01,Help04);
		}
		CurEnvTrigger("barrel01");
		if(VKeyObjFrame==48 && VarKey19==4)
		{
			call(SetTriggerObjFlag,1,_or,_SXObjInvisible);
			call(SetTriggerObjFlag,1,_or,_SXObjCollisionOff);
			CurEnvTrigger("lift01");
			call(SetTriggerObjFlag,1,_clr,_SXObjInvisible);
			call(SetTriggerObjFlag,1,_clr,_SXObjCollisionOff);
			if(VKeyObjTriggered==0)
			{
				call(KeyObjTrigger,1,1);
				float(_set,VarKey19,5);
			}
		}

		CurEnvTrigger("lift01");
		if(VKeyObjFrame==1 && VKeyObjTriggered==0 && VarKey19==5)
		{
			call(SetTriggerObjFlag,1,_or,_SXObjInvisible);
			call(SetTriggerObjFlag,1,_or,_SXObjCollisionOff);
			call(SetTriggerObjFlag,2,_clr,_SXObjInvisible);
			call(SetTriggerObjFlag,2,_clr,_SXObjCollisionOff);
			float(_set,VarKey19,6);
		}
	}
}
SubRoutine(BackgroundTriggerChecksScene3)
{
	print("timer3 is :::::::::::::::::::::::::::::::: ",timer3);
	print("VarKey19 is :::::::::::::::::::::::::::::: ",varkey19);

	//****** Calls in Chots until there are 6 of them in the room **********
	if(VarKey13>=14)
	{
		GetNumbActorsInSet("s2r2",_AIClassChot,TmpFloat);
		if(Tmpfloat<=4)
		{
			float(_add,timer,1);
		}
		if(timer>=6000)
		{
			vector(_set,Gactorangle,0,1024,0);
			vector(_set,Gactorpos,3677,1120,8154);
			initactor(WeaponPak,Gactorpos,Gactorangle,"s2r28");
			vector(_set,Gactorpos,3677,1074,8154);
			initactor(Chot,Gactorpos,Gactorangle,"s2r28",8);

			float(_set,timer,0);
		}
	}
	if(VCurSet=="s2r1")
	{
		CurEnvTrigger("door1");
		if(VTrigger==_DIRenvtrigger && VTRigger==_DIRaction)
		{
			message("Door Locked",120,10);
			sample(SFXAccessDenied,Gactorpos);
		}

		CurEnvTrigger("doorup");
		if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)
		{
			callsub(DoorOpen,1,1);
		}

		CurEnvTrigger("secsplit");
		if(VTrigger==_DIRenvtrigger && VTrigger==_DIRaction)
		{
			callsub(DoorOpen,1,1);
		}
	}
	elseif(VCurSet=="s2r11")
	{
		CurEnvTrigger("doorup");
		if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)
		{
			callsub(DoorOpen,1,1);
		}

		//********* grinder sequence **************
		CurEnvTrigger("activate");
		if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)
		{
			if(VarKey19==1) //******** Grinder works fine
			{
				if(VKeyObjTriggered==0 && VKeyObjFrame==0)
				{
					call(ActivateButton,"Recycling In Process",-1,FALSE);
					call(ActivateButtonSample,SFXValidFunction);
					CurEnvTrigger("barrel01");
					setkeyframe("s2r11","barrel01",0);
					call(KeyObjTrigger,34,1);
				}
				else
				{
					call(ActivateButton,"Wait Until Completion",-1,FALSE);
					call(ActivateButtonSample,SFXInvalidFunction);
				}
			}
			elseif(VarKey19==3) //********** Grinder has been destroyed
			{
				if(VKeyObjTriggered==0 && VKeyObjFrame==0)
				{
					call(ActivateButton,"Recycling In Process",-1,FALSE);
					call(ActivateButtonSample,SFXValidFunction);
					CurEnvTrigger("barrel01");
					call(KeyObjTrigger,48,1);
					float(_set,VarKey19,4);
				}
			}
			elseif(VarKey19>=4)
			{
				call(ActivateButton,"System Malfunction",-1,FALSE);
				call(ActivateButtonSample,SFXValidFunction);
			}				
		}

		//********* If someone goes through the grinder *************
		CurEnvTrigger("grinder2");
		if(VAICon!=0)
		{
			if(VarKey19==1)
			{
				if(VTrigger==_DIREnvTrigger)
				{
					setkeyframe("s2r11","barrel01",34);
					float(_set,VarKey19,2);
					float(_set,timer3,0);
					float(_clr,VarBit01,Help01);
				}
			}
		}
		else
		{
			callsub(Fall2death);
		}

		//*********** Starts pulsing light when grinder is destroyed **********
		if(VarKey19==2)
		{
			vector(_set,tmpvector,0,-80,-80);
			vector(_set,Gactorpos,3959,800,9385);
			spawnlight(LightPulseOmni3,-1,Gactorpos,tmpvector,EmptyVector,600);
			CurEnvTrigger("grinder");
			call(KeyObjTrigger,255,1);
			float(_set,VarKey19,3);
		}
	}
	elseif(VCurSet=="s2r2")
	{
		CurEnvTrigger("door23");
		if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)
		{
			message("Door Locked",120,10);
			sample(SFXAccessDenied,Gactorpos);
			direction(_clr,_DIRaction);
		}

		CurEnvTrigger("lift");
		if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)
		{
			call(KeyObjTrigger,255,1);
		}

		///////////////////////////////////
		///		EVACUATION SEQUENCE		///
		///////////////////////////////////

		//******* Initialize the sequence *************
		if(VarKey13==0)
		{
			CurEnvTrigger("seqstart");
			if(VTrigger==_DIREnvTrigger && VAICon==0)
			{
				float(_set,AiVisionToggle,1);
				float(_set,VarKey13,1);
			}
		}

		//******* Beginning of the sequence ************
		if(VarKey13==1)
		{
			CutScene("sequence");
			call(PlayerInput,0);
			float(_set,AIVisionToggle,1);
			float(_set,VarKey13,2);
		}
		//******** Audio : "evacuate all civilians from sector"
		if(VCutSceneFrameEqual==130)
		{
			if(VarKey13==2)
			{
				message("Play sample here",120,10);
				float(_set,VarKey13,3);
			}
		}
		//******** Have the cop gesturing to the dweller he is talking to *******
		if(VCutSceneFrameEqual==305)
		{
			if(VarKey13==3)
			{
				CurEnvTrigger("assign");
				if(VAIClass==_AIClassCop)
				{
					if(Vaction!=CopDramaticGesture)
					{
						spawnaction(CopDramaticGesture);
						sample(SFXSpreadOut,Gactorpos);
						float(_set,VarKey13,4);
					}
				}
			}
		}
		//******* Open Door to s2r3 ************
		if(VCutSceneFrameEqual==350)
		{
			if(VarKey13==4)
			{
				CurEnvTrigger("door23");
				callsub(DoorOpen,2,0);
				float(_set,VarKey13,5);
			}
		}
		//****** Everybody runs out the door *********
		if(VCutSceneFrameEqual==380);
		{
			if(VarKey13<=11 && VarKey13>=5)
			{
				CurEnvTrigger("assign");
				if(VAICon!=0)
				{
					call(AIfindpathwithspecificid,10);
					float(_add,VarKey13,1);
				}
			} 
		}
		//******* Brings the Chots In *************
		if(VCutSceneFrameEqual==600)
		{
			if(VarKey13<=12)
			{	
				vector(_set,Gactorangle,0,-1024,0);
				vector(_set,Gactorpos,4096,1650,8105);
				initactor(WeaponPak,Gactorpos,Gactorangle,"s2r3");
				vector(_set,Gactorpos,4096,1600,8105);
				initactor(Chot,Gactorpos,Gactorangle,"s2r3",15);

				vector(_set,Gactorangle,0,-1024,0);
				vector(_set,Gactorpos,4085,1600,7808);
				initactor(WeaponPak,Gactorpos,Gactorangle,"s2r3");
				vector(_set,Gactorpos,4085,1550,7808);
				initactor(Chot,Gactorpos,Gactorangle,"s2r3",16);
				sample(SFXChotGrunt,Gactorpos);
				float(_set,VarKey13,13);
			}
		}
		//******* Gives Control Back To Player - End Of Sequence *********
		if(VCutSceneFrameEqual==780)
		{
			float(_set,VarKey13,14);
			float(_set,AIVisionToggle,0);
			call(PlayerInput,1);
		}

		///////////////////////////////////
		///		GUN TURRET SEQUENCE		///
		///////////////////////////////////

		//******** Initialize Sequence - press button *****************
		CurEnvTrigger("turret01");
		if(VTrigger==_DIREnvTrigger)
		{
			if(VAIClass==_AIClassCop && VRank==_RankCommander)
			{
				if(HelpVar&=help09 && TutorialToggle==1)
				{
					ClearTutorialLines();
					AddTutorialLine("To activate the [20:250:50]GUN TURRET[255:255:255]@ press");
					AddTutorialLine("your [20:250:50]ACTION[255:255:255] button in front of the");
					AddTutorialLine("console.");
					AddTutorialLine(" ");
					AddTutorialLine("In the [20:250:50]GUN TURRET[255:255:255]@ press your");
					AddTutorialLine("[20:250:50]FIRE[255:255:255] button to shoot and aim with");
					AddTutorialLine("[20:250:50]UP[255:255:255] and [20:250:50]DOWN[255:255:255]. To rotate the turret");
					AddTutorialLine("press [20:250:50]LEFT[255:255:255] and [20:250:50]RIGHT[255:255:255].");
					AddTutorialLine(" ");
					AddTutorialLine("  [100:100:100]             Press Any Key        ");
					AddTutorialLine("  [100:100:100]             To Continue          ");
					DisplayTutorialScreen("[255:255:20]GUN TURRET[150:150:150]",15,15);
				}
			}
		
			if(VTrigger==_DIRaction && VKeyObjFrame==0 && VarKey14==0)
			{
				if(VAIClass==_AIClassCop && VRank==_RankCommander)
				{
					call(ActivateButton,"Gun Turret Activated",-1,FALSE);
					call(ActivateButtonSample,SFXValidFunction);
					call(PlayerInput,0);
					CutScene("turret");
					float(_set,timer3,0);
					float(_set,VarKey14,1);
				}
				else
				{
					message("Only commanders can Operate This Unit.",200,10);
					sample(SFXAccessDenied,Gactorpos);
				}
			}
		}

		//******* Camera rotates - delay before Gun Turret animation starts ***********
		if(VarKey14==1)
		{
			float(_add,timer3,1);
			if(timer3>=40)
			{
				vector(_set,Gactorpos,1709,1061,9272);
				sample(SFXGunTurretWrap,Gactorpos);
				CurEnvTrigger("turret01");
				call(KeyObjTrigger,10,1);
				CurEnvTrigger("turret02");
				call(KeyObjTrigger,10,1);
				CurEnvTrigger("barrel");
				call(KeyObjTrigger,1,1);
				float(_set,VarKey14,2);
				float(_set,timer3,0);
				direction(_clr,_DIRaction);
			}
		}

		//********** Domina gets into her "Tron" position *****************
		CurEnvTrigger("turret01");
		if(VKeyObjFrame==5 && VarKey14==2)
		{
			if(Vaction!=DominaGunInit)
			{
				spawnaction(DominaGunInit);
				float(_set,VaRKey14,3);
			}
		}

		//*********** HUD change to ROCKET_HUD ********************
		if(VKeyObjFrame>=9 && VarKey14==3)
		{
			if(VCutScene==0)
			{
				CurEnvTrigger("turret01");
				call(SetTriggerObjFlag,0,_or,_SXObjInvisible);
				call(KeyObjTrigger,13,1);
				CurEnvTrigger("turret02");
				call(SetTriggerObjFlag,0,_or,_SXObjInvisible);
				call(KeyObjTrigger,13,1);
				float(_set,SniperMode,1);
				call(ChangeSniperMode,1,1);
				CurEnvTrigger("barrel");
				call(SetTriggerObjFlag,1,_clr,_SXObjInvisible);
				setkeyframe("s2r2","barrel",4);
				if(VarKey15==0)
				{
					vector(_set,TmpVector,0,0,0);
					call(SniperKFObj,TRUE,TmpVector);
					float(_set,VarKey15,1);
				}
				CurEnvTrigger("turret02");
				
				float(_set,VarKey14,4);
			}
		}

		//******** Turn Collision On (to be explodable) on Turret ****************
		if(VarKey14==4 && VKeyObjFrame>=13)
		{
			call(PlayerInput,1);
			CurEnvTrigger("turret01");
			call(SetTriggerObjFlag,0,_clr,_SXObjCollisionOff);
			CurEnvTrigger("turret02");
			call(SetTriggerObjFlag,0,_clr,_SXObjCollisionOff);			
			float(_set,VarKey14,5);
		}

		//******** Assign Special KFControl to Turret *******************
		if(VarKey14==5)
		{
			CurEnvTrigger("turctrl");
			if(VTrigger==_DIREnvTrigger)
			{
				CurEnvTrigger("turret01");
				if(VKeyObjFrame==13 && VTrigger==_DIRleft)
				{
					setkeyframe("s2r2","turret01",26);
				}
				if(VKeyObjFrame==26 && VTrigger==_DIRright)
				{
					setkeyframe("s2r2","turret01",13);
				}
				if(VKeyObjFrame>=13)
				{
					call(KeyObjControl,_DIRleft,_DIRright,13,26,SFXGunTurretHorizontal);
					CurEnvTrigger("barrel");
					call(KeyObjControl,_DIRBackward,_DIRforward,3,5,SFXGunTurretVertical);
				}
				callsub(Sub_GunTurretHandler);
				if(VTrigger==_DIRaction)
				{
					call(PlayerInput,0);
					float(_set,VarKey14,6);
					direction(_clr,_DIRaction);
				}
			}
		}

		//******** Action Key has been pressed. Turret reset to original position **********
		if(VarKey14==6)
		{
			CurEnvTrigger("Turret01");
			call(SetTriggerObjFlag,0,_or,_SXObjCollisionOff);
			call(KeyObjTrigger,0,-1);
			CurEnvTrigger("turret02");
			call(SetTriggerObjFlag,0,_or,_SXObjCollisionOff);
			call(KeyObjTrigger,0,-1);
			float(_set,VarKey14,7);
		}
		
		//******** Reset HUD to normal **************
		if(VarKey14==7)
		{
			CurEnvTrigger("Turret01");
			if(VKeyObjFrame==9)
			{
				float(_set,SniperMode,0);
				call(ChangeSniperMode,0,1);
				CutScene("endseq");
				CurEnvTrigger("turret02");
				call(SetTriggerObjFlag,0,_clr,_SXObjInvisible);
				CurEnvTrigger("barrel");
				call(SetTriggerObjFlag,1,_or,_SXObjInvisible);
				if(VarKey15!=0)
				{
					vector(_set,TmpVector,0,0,0);
					call(SniperKFObj,FALSE,TmpVector);
					float(_set,VarKey15,0);
				}
				float(_set,VarKey14,8);
			}
		}

		//******* Domina gets back into an idle **************
		if(VarKey14==8)
		{
			CurEnvTrigger("turret01");
			if(VKeyObjFrame==0 && VKeyObjTriggered==0)
			{
				if(VAIClass==_AIClassCop && VRank==_RankCommander)
				{
					if(Vaction!=DomIdleNoGun)
					{
						spawnaction(DomIdleNoGun);
						call(PlayerInput,1);
						if(VAICon==0)
						{
							ActorFlag(_clr,_AFLAGnorotation);
						}
						float(_set,VarKey14,0);
					}
				}
			}
		}
	}
	elseif(VCurSet=="s2r3")
	{
		CurEnvTrigger("doorup");
		if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)
		{
			callsub(DoorOpen,1,1);
		}
	}
	elseif(VCurSet=="s2r9")
	{

		if(VAICon==0)
		{
			float(_add,CommandTimer,1);
			if(CommandTimer>=250)
			{
				GetNumbActorsInSet("s2r9",_AIClassChot,TmpFloat);
				if(TmpFloat<3)
				{
					vector(_set,Gactorpos,4701,100,15594);
					vector(_set,Gactorangle,0,2048,0);
					InitActor(WeaponPAK,Gactorpos,Gactorangle,"S2r9");
					vector(_set,Gactorpos,4701,50,15594);
					InitActor(Chot,Gactorpos,Gactorangle,"S2r9",TRUE,88);
				}
				float(_set,CommandTimer,0);		
			}
		}

		CurEnvTrigger("lift");
		if(VKeyObjTriggered==0 || VKeyObjFrame==11)
		{
			callsub(Sub_SetCameraNormal);
		}
		else
		{
			Camera(elevator_camera_distance,elevator_camera_angle);
			Target(elevator_camera_Tdistance,elevator_camera_Tangle);
		}

		CurEnvTrigger("panel1");
		if(VTrigger==_DIREnvTrigger)
		{
			if(VTrigger==_DIRaction)
			{
				CurEnvTrigger("lift");
				if(VKeyObjFrame==0 && VKeyObjTriggered==0)
				{
					call(ActivateButton,0,-1,FALSE);
					call(ActivateButtonSample,SFXValidFunction);			
					call(KeyObjTrigger,11,1);
					kfsample(SFXLiftStart,SFXLiftMove,-1,SFXLiftEnd);
					direction(_clr,_DIRaction);
				}
			}
		}

		CurEnvTrigger("panel2");
		if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)
		{
			CurEnvTrigger("lift");
			if(VKeyObjFrame==11 && VKeyObjTriggered==0)
			{
				call(ActivateButton,0,-1,FALSE);
				call(ActivateButtonSample,SFXValidFunction);
				call(KeyObjTrigger,0,-1);
				kfsample(SFXLiftStart,SFXLiftMove,-1,SFXLiftEnd);
				direction(_clr,_DIRaction);
			}
		}

		CurEnvTrigger("inscan");
		callsub(ScanCheck,_AIClassCop,_RankSergeantL);

		CurEnvTrigger("doorup");
		if(AccessGranted==1)
		{
			message("Access Granted",120,10);
			float(_set,AccessGranted,0);
			callsub(DoorOpen,1,1);
		}

		CurEnvTrigger("fake");
		if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)
		{
			message("Door is melted shut.",120,10);
			sample(SFXAccessDenied,Gactorpos);
			direction(_clr,_DIRaction);
		}
	}

	elseif(VCurSet=="s2r13")
	{
		CurEnvTrigger("laserfce");
		if(VTrigger==_DIREnvTrigger)
		{
			colstate(_or,_COLelectricity);
		}
	}
	elseif(VCurSet=="s2r15")
	{

		/////////////////////////////////////////////
		/////		VICTIM ANALYSIS SEQUENCE	/////
		/////////////////////////////////////////////
		if(VarKey17!=0)
		{
			//****** Check if victims are still in the cage ********
			if(MissionLevel1==0)
			{
				CurEnvTrigger("isin");
				GetNumbActorsInSet("s2r15",_AIClassPimp,TmpFloat);
				if(TmpFloat==0)
				{
					float(_set,MissionLevel1,1);
				}
				else
				{
					float(_set,MissionLevel1,4);
				}
			}
			
			//******** No More victims in the cage, call the bridge *************
			if(MissionLevel1==1)
			{
				CurEnvTrigger("cage");
				if(VKeyObjFrame==0)
				{
					vector(_set,Gactorpos,8460,1695,10843);
					vector(_set,Gactorangle,0,0,0);
					InitActor(victimmale,Gactorpos,Gactorangle,"s2r15",FALSE);
					vector(_set,Gactorpos,8460,1695,10732);
					vector(_set,Gactorangle,0,0,0);
					InitActor(victimmale,Gactorpos,Gactorangle,"s2r15",FALSE);
					call(KeyObjTrigger,32,1);
					float(_set,MissionLevel1,3);
				}
				else
				{
					if(VKeyObjTriggered==0)
					{
						call(KeyObjTrigger,0,-1);
					}
				}
			}

			if(MissionLevel1==3)
			{
				CurEnvTrigger("cage");
				if(VKeyObjFrame>=32)
				{
					float(_set,MissionLevel1,4);
				}
			}
			//********* When cage has reached its destination, open upper lid **********
			if(MissionLevel1==4)
			{
				CurEnvTrigger("cagecap");
				if(VKeyObjTriggered==0)
				{
					call(KeyObjTrigger,255,1);
					float(_set,MissionLevel1,5);
				}
			}
			if(MissionLevel1==5)
			{
				CurEnvTrigger("cagecap");
				if(VKeyObjFrame==1)
				{
					float(_set,MissionLevel1,6);
				}
			}


			//********** Swallow victim, with a beam of blue/white light **********
			if(MissionLevel1==6)
			{
				CurEnvTrigger("isin");
				if(VTrigger==_DIREnvTrigger)
				{
					if(VAICon!=0)
					{
						// Add special effect here
						KillActor();
						float(_set,MissionLevel1,7);
					}
				}
			}						
			
			//*********** Move the podtube down *************
			if(MissionLevel1==7)
			{
				if(VarKey17==1)
				{
					CurEnvTrigger("tube01");
				}
				if(VarKey17==2)
				{
					CurEnvTrigger("tube02");
				}
				if(VarKey17==3)
				{
					CurEnvTrigger("tube03");
				}
				if(VarKey17==4)
				{
					CurEnvTrigger("tube04");
				}
				call(KeyObjTrigger,1,1);
				if(VKeyObjFrame==1)
				{
					float(_set,MissionLevel1,8);
				}
			}
			//********* Put the victim in the tube **********
			if(MissionLevel1==8)
			{
				if(VarKey17==1)
				{
					CurEnvTrigger("tube01");
					vector(_set,Gactorpos,8758,1181,10152);
					vector(_set,Gactorangle,0,0,0);
				}
				if(VarKey17==2)
				{
					CurEnvTrigger("tube02");
					if(VTrigger==_DIREnvTrigger && VAICon!=0 && VAIClass==_AIClassScientist)
					{
						call(AIfindpathwithspecificid,4);
					}
					vector(_set,Gactorpos,8911,1181,9848);
					vector(_set,Gactorangle,0,0,0);
				}
				if(VarKey17==3)
				{
					CurEnvTrigger("tube03");
					if(VTrigger==_DIREnvTrigger && VAICon!=0 && VAIClass==_AIClassScientist)
					{
						call(AIfindpathwithspecificid,3);
					}
					vector(_set,Gactorpos,8018,1263,9853);
					vector(_set,Gactorangle,0,0,0);
				}
				if(VarKey17==4)
				{	
					CurEnvTrigger("tube04");
					vector(_set,Gactorpos,8171,1263,10144);
					vector(_set,Gactorangle,0,0,0);
				}
				InitActor(victimmale,Gactorpos,Gactorangle,"s2r15",FALSE);
				float(_set,timer3,1);
				float(_set,MissionLevel1,9);
				float(_rnd2,timer4,10);
				float(_round,timer4);

			}
			//****** Scales down the actor *********
			if(MissionLevel1==9)
			{	
				float(_sub,timer3,0.0005);
				if(VarKey17==1)
				{
					CurEnvTrigger("intube01");
				}
				if(VarKey17==2)
				{
					CurEnvTrigger("intube02");
				}
				if(VarKey17==3)
				{
					CurEnvTrigger("intube03");
				}
				if(VarKey17==4)
				{
					CurEnvTrigger("intube04");
				}
				if(VTrigger==_DIREnvTrigger && VAICon!=0 && VAIClass==_AIClassPimp)
				{
					if(Vaction!=VictimStrangle)
					{
						spawnaction(VictimStrangle);
					}
					if(timer4<6)
					{						
						scalebonematrix(0,timer3,_SXBoneAttAbsolute);
					}
					if(timer4>=6)
					{
						scalebonematrix(1,timer3,_SXBoneAttAbsolute);
					}
				}
				if(timer3<=0.21)
				{
					float(_set,MissionLevel1,10);
					float(_set,timer2,0);
				}
			}
			if(MissionLevel1==11)
			{
				if(timer4<6)
				{
					message("Experiment Successful",120,10);
				}
				if(timer4>=6)
				{
					message("Experiment Has Failed",120,10);
				}
				float(_set,MissionLevel1,12);
			}
			if(MissionLevel1==12)
			{
				if(VarKey17==1)
				{
					CurEnvTrigger("intube01");
				}
				if(VarKey17==2)
				{
					CurEnvTrigger("intube02");
				}
				if(VarKey17==3)
				{
					CurEnvTrigger("intube03");
				}
				if(VarKey17==4)
				{
					CurEnvTrigger("intube04");
				}
				if(VTrigger==_DIREnvTrigger && VAICon!=0 && VAIClass==_AIClassPimp)
				{
					message("Body dissolved",120,10);
					KillActor();
				}
			}
			if(MissionLevel1==13)
			{
				if(VarKey17==1)
				{
					CurEnvTrigger("tube01");
				}
				if(VarKey17==2)
				{
					CurEnvTrigger("tube02");
				}
				if(VarKey17==3)
				{
					CurEnvTrigger("tube03");
				}
				if(VarKey17==4)
				{
					CurEnvTrigger("tube04");
				}
				call(KeyObjTrigger,0,-1);
				float(_set,timer2,0);
				float(_set,timer3,0);
				float(_set,timer4,0);
				float(_set,VarKey17,0);
				float(_set,MissionLevel1,0);
			}
			if(MissionLevel1>=10)

			{
				if(VarKey17==1)
				{
					CurEnvTrigger("intube01");
				}
				if(VarKey17==2)
				{
					CurEnvTrigger("intube02");
				}
				if(VarKey17==3)
				{
					CurEnvTrigger("intube03");
				}
				if(VarKey17==4)
				{
					CurEnvTrigger("intube04");
				}
				if(VTrigger==_DIREnvTrigger && VAICon!=0 && VAIClass==_AIClassCop)
				{
					if(timer4<10)
					{
						scalebonematrix(0,0.2,_SXBoneAttAbsolute);
					}
					if(timer4>=10)
					{
						scalebonematrix(1,0.2,_SXBoneAttAbsolute);
					}
				}
			}
		}
		CurEnvTrigger("tube01");
		if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)
		{
			if(VAIClass==_AIClassScientist)
			{
				if(VarKey17==0)
				{
					if(VAICon==0)
					{
						call(ActivateButton,"Confinement Tube #1 Activated",-1,FALSE);
						call(ActivateButtonSample,SFXValidFunction);
					}
					float(_set,MissionLevel1,0);
					float(_set,VarKey17,1);
				}
				else
				{
					if(VAICon==0)
					{
						call(ActivateButton,"Experiment Already In Progress",-1,FALSE);
						call(ActivateButtonSample,SFXInvalidFunction);
					}
				}
			}
			else
			{
				message("Improper Command",120,10);
				sample(SFXUnrecognized,Gactorpos);
			}
		}
		CurEnvTrigger("tube02");
		if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)
		{
			if(VAIClass==_AIClassScientist)
			{
				if(VarKey17==0)
				{
					if(VAICon==0)
					{
						call(ActivateButton,"Confinement Tube #2 Activated",-1,FALSE);
						call(ActivateButtonSample,SFXValidFunction);
					}
					float(_set,MissionLevel1,0);
					float(_set,VarKey17,2);
				}
				else
				{
					if(VAICon==0)
					{
						call(ActivateButton,"Experiment Already In Progress",-1,FALSE);
						call(ActivateButtonSample,SFXInvalidFunction);
					}
				}
			}
			else
			{
				message("Improper Command",120,10);
				sample(SFXUnrecognized,Gactorpos);
			}
		}
		CurEnvTrigger("tube03");
		if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)
		{
			if(VAIClass==_AIClassScientist)
			{
				
				if(VarKey17==0)
				{
					if(VAICon==0)
					{
						call(ActivateButton,"Confinement Tube #3 Activated",-1,FALSE);
						call(ActivateButtonSample,SFXValidFunction);
					}
					float(_set,MissionLevel1,0);
					float(_set,VarKey17,3);
				}
				else
				{
					if(VAICon==0)
					{
						call(ActivateButton,"Experiment Already In Progress",-1,FALSE);
						call(ActivateButtonSample,SFXInvalidFunction);
					}
				}
			}
			else
			{
				message("Improper Command",120,10);
				sample(SFXUnrecognized,Gactorpos);
			}
		}
		CurEnvTrigger("tube04");
		if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)
		{
			if(VAIClass==_AIClassScientist)
			{
				if(VarKey17==0)
				{
					if(VAICon==0)
					{
						call(ActivateButton,"Confinement Tube #4 Activated",-1,FALSE);
						call(ActivateButtonSample,SFXValidFunction);
					}
					float(_set,MissionLevel1,0);
					float(_set,VarKey17,4);
				}
				else
				{
					if(VAICon==0)
					{
						call(ActivateButton,"Experiment Already In Progress",-1,FALSE);
						call(ActivateButtonSample,SFXInvalidFunction);
					}
				}
			}
			else
			{
				message("Improper Command",120,10);
				sample(SFXUnrecognized,Gactorpos);
			}
		}

		CurEnvTrigger("lift01");
		if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)
		{
			if(VKeyObjTriggered==0)
			{
				call(KeyObjTrigger,1,1);
			}
		}

		CurEnvTrigger("lift01b");
		if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)
		{
			CurEnvTrigger("lift01");
			if(VKeyObjTriggered==0)
			{
				call(KeyObjTrigger,0,-1);
			}
		}
		
		CurEnvTrigger("warning");
		if(VTrigger==_DIREnvTrigger && VAICon==0)
		{
			dmessage("step back motherfucker !",50,150);
		}
		
		CurEnvTrigger("shoot");
		if(VTrigger==_DIREnvTrigger && VAICon==0)
		{
			ClearDMessage();
			dmessage("I warned you dickhead !",50,150);
			call(AICHangePlayerToEnemy);
		}
		
		
		CurEnvTrigger("lift02");
		if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)
		{
			if(VKeyObjTriggered==0)
			{
				call(KeyObjTrigger,1,1);
			}
		}

		CurEnvTrigger("lift02b");
		if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)
		{
			CurEnvTrigger("lift02");
			if(VKeyObjTriggered==0)
			{
				call(KeyObjTrigger,0,-1);
			}
		}
	}
	elseif(VCurSet=="s2r19")
	{
		CurEnvTrigger("doorup");
		if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)
		{
			if(VAIClass==_AIClassCop)
			{
				callsub(DoorOpen,1,1);
			}
			else
			{
				message("Access Restricted to Security Personnel",120,10);
				sample(SFXAccessDenied,Gactorpos);
			}
		}

		//******************** Activate the DefenseBot sequence **************
		CurEnvTrigger("Bot01");
		if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)
		{
			if(VAIClass==_AIClassCop)
			{
				if(VarKey18==0)
				{
					call(ActivateButton,"Defense Bot Activated",-1,FALSE);
					call(ActivateButtonSample,SFXValidFunction);
					float(_set,VarKey18,1)
				}
				else
				{
					call(ActivateButton,"Bot Already Activated",-1,FALSE);
					call(ActivateButtonSample,SFXInvalidFunction);
				}
			}
			else
			{
				call(ActivateButton,"Security Personnel Only",-1,FALSE);
				call(ActivateButtonSample,SFXInvalidFunction);
			}				
		}
		
		//******************* Activate the Companion Bot sequence ***************
		CurEnvTrigger("Bot02");
		if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)
		{
			if(VAIClass==_AIClassCop)
			{
				if(VarKey18==0)
				{
					call(ActivateButton,"Companion Bot Activated",-1,FALSE);
					call(ActivateButtonSample,SFXValidFunction);
					float(_set,VarKey18,2)
				}
				else
				{
					call(ActivateButton,"Bot Already Activated",-1,FALSE);
					call(ActivateButtonSample,SFXInvalidFunction);
				}
			}
			else
			{
				call(ActivateButton,"Security Personnel Only",-1,FALSE);
				call(ActivateButtonSample,SFXInvalidFunction);
			}				
		}

		//*********** Spawn Defense Bot OR Companion Bot ************
		if(VarKey18>0 && VarKey18<3)
		{
			call(PlayerInput,0);
			CurEnvTrigger("botctrl")
			call(KeyObjTrigger,255,1);
			vector(_set,Gactorangle,0,0,0);
			vector(_set,Gactorpos,7855,405,11882);
			if(VarKey18==1)
			{
				InitActor(DefensiveBot,Gactorpos,Gactorangle,"s2r19");
				float(_set,VarKey18,3);
			}
			elseif(VarKey18==2)
			{
				InitActor(CompanionBot,Gactorpos,Gactorangle,"s2r19");
				float(_set,VarKey18,4);
			}
			direction(_clr,_DIRaction);
		}
	
		//********* Moves the camera over to the Bot Box *************
		CurEnvTrigger("botctrl");
		if(VKeyObjFrame==3 && VarKey18==3)
		{
			if(HelpVar&=help07)
			{
				call(ExpSet2,45,1,1);
			}
			float(_set,VarKey18,5);
			float(_set,timer3,0);
		}

		if(VKeyObjFrame==3 && VarKey18==4)
		{
			if(HelpVar&=help08)
			{
				call(ExpSet2,45,1,1);
			}
			float(_set,VarKey18,6);
			float(_set,timer3,0);
		}

		//************** Display Tutorial lines *************
		if(VarKey18==5)
		{
			float(_add,timer3,1)
			if(HelpVar&=help07)
			{
				if(timer3==50)
				{
					ClearTutorialLines();
					AddTutorialLine("Stays in close proximity to [20:250:50]Bot Operator[255:255:255]");
					AddTutorialLine("[20:250:50]Bot[255:255:255] will fire at any attacker.");
					AddTutorialLine(" ");
					AddTutorialLine("To activate the [20:250:50]Bot[255:255:255] just");
					AddTutorialLine("walk past it and it will");
					AddTutorialLine("attach itself to you.");
					AddTutorialLine(" ");
					AddTutorialLine("  [100:100:100]             Press Any Key        ");
					AddTutorialLine("  [100:100:100]             To Continue          ");
					DisplayTutorialScreen("[255:255:20]DEFENSIVE BOT [150:150:150]Guardian Class",15,15);
				}
				if(timer3==55)
				{
					float(_xor,HelpVar,help07);
					call(PauseToggle);
				}
			}
			if(timer3>=90)
			{
				call(PlayerInput,1);
				float(_set,timer3,0);
				float(_set,VarKey18,7);
			}
		}

		if(VarKey18==6)
		{
			float(_add,timer3,1)
			if(HelpVar&=help08)
			{
				if(timer3==50)
				{
					ClearTutorialLines();
					AddTutorialLine("Provides additional firepower during a confrontation. ");
					AddTutorialLine("Fires only while [20:250:50]Bot Operator[255:255:255]");
					AddTutorialLine("is pressing his [20:250:50]FIRE[255:255:255] button.");
					AddTutorialLine(" ");
					AddTutorialLine("To activate the [20:250:50]Bot[255:255:255] just");
					AddTutorialLine("walk past it and it will");
					AddTutorialLine("attach itself to you.");
					AddTutorialLine(" ");
					AddTutorialLine("  [100:100:100]             Press Any Key        ");
					AddTutorialLine("  [100:100:100]             To Continue          ");
					DisplayTutorialScreen("[255:255:20]COMPANION BOT [150:150:150]Support Class",15,15);
				}
				if(timer3==55)
				{
					float(_xor,HelpVar,help08);
					call(PauseToggle);
				}
			}
			if(timer3>=90)
			{
				call(PlayerInput,1);
				float(_set,timer3,0);
				float(_set,VarKey18,7);
			}
		}
	}
	elseif(VCurSet=="s2r25")
	{
		CurEnvTrigger("doorup");
		if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)
		{
			callsub(DoorOpen,1,1);
		}
	}

	elseif(VCurSet=="s2r13")
	{
		//******** If a victim has been killed, spawn another one **********
		GetNumbActorsInSet("s2r13",_AIClassCop,TmpFloat);
		if(TmpFloat<7)
		{
			if(VAICon==0)
			{
				float(_add,timer4,1);
				if(timer4>=20);
				{
					vector(_set,Gactorpos,6992,1276,9612);
					vector(_set,Gactorangle,0,2048,0);
					float(_rnd2,TmpFloat1,10);
					if(TmpFloat1<5)
					{
						InitActor(victimmale,Gactorpos,Gactorangle,"s2r13",TRUE,2);
					}
					else(TmpFloat1>=5)
					{
						InitActor(victimfemale,Gactorpos,Gactorangle,"s2r13",TRUE,2);
					}
					float(_set,timer4,0);
				}
			}
		}

		CurEnvTrigger("killme");
		if(VTrigger==_DIREnvTrigger && VAICon!=0)
		{
			KillActor();
		}
	}
}
